/*  Floating Point(Double) Calc Subroutine
        void d_pai(unsigned char *x,int n);
        Copyright(c) 2007,  S.SAKAI     2007.3.6    */
#include    "fltmpu.h"

/*      x = pai     */
void d_pai(unsigned char *x,int n)
{ unsigned long     *ux;

    ux = (unsigned long *)x;
    switch(n) {
        case    0:      /* pai */
#if     FLTMPU
            *ux = 0x400921fb;
            *(ux+1) = 0x54442d18;
#else
            *(ux+1) = 0x400921fb;
            *ux = 0x54442d18;
#endif
            break;
        case    1:      /* pai*2 */
#if     FLTMPU
            *ux = 0x401921fb;
            *(ux+1) = 0x54442d18;
#else
            *(ux+1) = 0x401921fb;
            *ux = 0x54442d18;
#endif
            break;
        case    2:      /* pai/2 */
#if     FLTMPU
            *ux = 0x3ff921fb;
            *(ux+1) = 0x54442d18;
#else
            *(ux+1) = 0x3ff921fb;
            *ux = 0x54442d18;
#endif
            break;
        case    3:      /* pai*3/2 */
#if     FLTMPU
            *ux = 0x4012d97c;
            *(ux+1) = 0x7f3321d2;
#else
            *(ux+1) = 0x4012d97c;
            *ux = 0x7f3321d2;
#endif
            break;
        case    4:      /* pai/4 */
#if     FLTMPU
            *ux = 0x3fe921fb;
            *(ux+1) = 0x54442d18;
#else
            *(ux+1) = 0x3fe921fb;
            *ux = 0x54442d18;
#endif
            break;
        case    5:      /* 180/pai */
#if     FLTMPU
            *ux = 0x404ca5dc;
            *(ux+1) = 0x1a63c1f8;
#else
            *(ux+1) = 0x404ca5dc;
            *ux = 0x1a63c1f8;
#endif
            break;
    }
}
