/*  Floating Point(Double) Calc Subroutine
        void _d_addz(unsigned char *x,unsigned char *y);
        void _dmltz(unsigned char *x,unsigned char *y);
        void _ddivz(unsigned char *x,unsigned char *y);

        Copyright(c) 2007,  S.SAKAI     2007.3.5    */
#include    "fltmpu.h"

void    _regshld(unsigned char *);
void    _dnormshl(unsigned char *,int);
int     _dcmpxy(unsigned char *,unsigned char *);

void _daddz(unsigned char *x,unsigned char *y)
{ int               i;
  unsigned long     a,b;
  unsigned short    *ux,*uy;

    b = 0;
    ux = (unsigned short *)x;
    uy = (unsigned short *)y;
#if     FLTMPU
    for (i=3;i>=0;i--) {
#else
    for (i=0;i<4;i++) {
#endif
        a = *(ux+i);
        a += *(uy+i);
        a += b;
        *(ux+i) = a;
        b  = a >> 16;
    }
}

void _dmltz(unsigned char *x,unsigned char *y)
{ int               i,j,k;
  unsigned long     a,b;
  unsigned char     f[16],*c;
  unsigned long     *uf,*ux;

    ux = (unsigned long *)x;
    uf = (unsigned long *)f;
    for(i=0;i<4;i++) *(uf+i) = 0;
#if     FLTMPU
    for(i=7;i>=0;i--) {
        for(j=7;j>=0;j--) {
#else
    for(i=0;i<8;i++) {
        for(j=0;j<8;j++) {
#endif
            a = x[i];
            a *= y[j];
            c = f + i + j;
#if     FLTMPU
            a += *(c+1);
            a += (*c << 8);
            *c = a >> 8;
            *(c+1) = a & 0xff;
#else
            a += *c;
            a += (*(c+1) << 8);
            *c = a & 0xff;
            *(c+1) = a >> 8;
#endif
            if (a & 0x10000) {
#if     FLTMPU
                k = -1;
#else
                k = 2;
#endif
                while(1) {
                    b = f[i+j+k];
                    b++;
                    f[i+j+k] = b;
                    if ((b & 0x100) == 0) break;
#if     FLTMPU
                    k--;
#else
                    k++;
#endif
                }
            }
        }
    }

#if     FLTMPU
    *ux = *uf << 4;
    *(ux+1) = *(uf+1) << 4;
    *(uf+1) >>= 28;
    *ux += *(uf+1);
    *(uf+2) >>= 28;
    *(ux+1) += *(uf+2);
#else
    *(ux+1) = *(uf+3) << 4;
    *ux = *(uf+2) << 4;
    *(uf+2) >>= 28;
    *(ux+1) += *(uf+2);
    *(uf+1) >>= 28;
    *ux += *(uf+1);
#endif
}

void _ddivz(unsigned char *x,unsigned char *y)
{ int       a,i,cy;
  unsigned char     f[8];
  unsigned long     *uf,*ux,*uy;

    ux = (unsigned long *)x;
    uy = (unsigned long *)y;
    uf = (unsigned long *)f;

    *uf = 0;
    *(uf+1) = 0;
    for(i=0;i<60;i++) {
        a = _dcmpxy(x,y);
        if (a == 0) {
#if     FLTMPU
            f[7] |= 0x1;
#else
            f[0] |= 0x1;
#endif
            _dnormshl(f,60-i);
            break;
        }
        else if (a > 0) {
#if     FLTMPU
            f[7] |= 0x1;
            if (*(ux+1) < *(uy+1)) cy = 1;
            else cy = 0;
            *(ux+1) -= *(uy+1);
            *ux -= *uy;
            if (cy) *ux -= 1;
#else
            f[0] |= 0x1;
            if (*ux < *uy) cy = 1;
            else cy = 0;
            *ux -= *uy;
            *(ux+1) -= *(uy+1);
            if (cy) *(ux+1) -= 1;
#endif
        }
        _regshld(f);
        _regshld(x);
    }
    *ux = *uf;
    *(ux+1) = *(uf+1);
}
