/*  Floating Point(Float) Calc Subroutine
        void _fmlt(unsigned char *x,unsigned char *y);
        void _fdivz(unsigned char *x,unsigned char *y);
        Copyright(c) 2007,  S.SAKAI     2007.4.24   */
#include    "fltmpu.h"

void _fmltz(unsigned char *x,unsigned char *y)
{ int               i,j,k;
  unsigned long     a,b;
  unsigned char     f[8],*c;
  unsigned long     *uf,*ux;

    ux = (unsigned long *)x;
    uf = (unsigned long *)f;
    *uf = 0;
    *(uf+1) = 0;
#if     FLTMPU
    for(i=3;i>=0;i--) {
        for(j=3;j>=0;j--) {
#else
    for(i=0;i<4;i++) {
        for(j=0;j<4;j++) {
#endif
            a = x[i];
            a *= y[j];
            c = f + i + j;
#if     FLTMPU
            a += *(c+1);
            a += (*c << 8);
            *c = a >> 8;
            *(c+1) = a & 0xff;
#else
            a += *c;
            a += (*(c+1) << 8);
            *c = a & 0xff;
            *(c+1) = a >> 8;
#endif
            if (a & 0x10000) {
#if     FLTMPU
                k = -1;
#else
                k = 2;
#endif
                while(1) {
                    b = f[i+j+k];
                    b++;
                    f[i+j+k] = b;
                    if ((b & 0x100) == 0) break;
#if     FLTMPU
                    k--;
#else
                    k++;
#endif
                }
            }
        }
    }

#if     FLTMPU
    *uf <<= 4;
    k = *(uf+1) & 0x8000000;
    *(uf+1) >>= 28;
#else
    *(uf+1) <<= 4;
    k = *uf & 0x8000000;
    *uf >>= 28;
#endif
    *uf += *(uf+1);
    if (k) *uf += 1;
    *ux = *uf;
}

void _fdivz(unsigned char *x,unsigned char *y)
{ int       i;
  unsigned long     f,*ux,*uy;

    ux = (unsigned long *)x;
    uy = (unsigned long *)y;
    f = 0;
    for(i=0;i<28;i++) {
        if (*ux == *uy) {
            f |= 0x1;
            f <<= (28-i);
            break;
        }
        else if (*ux > *uy) {
            f |= 0x1;
            *ux -= *uy;
        }
        f <<= 1;
        *ux <<= 1;
    }
    *ux = f;
}
