/*  Floating Point(Float) Calc Subroutines
        Copyright(c) 2007,  S.SAKAI     2007.3.5    */
#include    "fltmpu.h"

/*      Float -> w &     */
int _fnorm(unsigned char *x)
{ int   a;
  unsigned long *ux;

    ux = (unsigned long *)x;
    a = *ux;
    a >>= 23;

    *ux &= 0x7fffff;
    *ux |= 0x800000;
    *ux <<= 5;
    return(a);
}

/*      w &  -> Float    */
void _fanorm(unsigned char *x,int a)
{ unsigned long *ux;
  int   i;

    ux = (unsigned long *)x;
#if     FLTMPU
    if (x[0] & 0x20) {
#else
    if (x[3] & 0x20) {
#endif
        a++;
        *ux +=  0x20; 
        if (*ux & 0xc0000000) {
            i = 7;
            a++;
        }
        else i=6;
    }
    else {
        *ux +=  0x10; 
        if (*ux & 0xe0000000) {
            i = 6;
            a++;
        }
        else i= 5;
    }
    *ux >>= i;
    *ux &= 0x7fffff;

    a <<= 23;
    *ux |= a;
}

/*      x[3]..x[0] -> 0x1xxxxxxx    */
int _fnorma(unsigned char *x)
{ int           a,b,f;
  unsigned long *ux;

    ux = (unsigned long *)x;

    b = 0;
    f = 0;
    while(1) {
#if     FLTMPU
        a = x[0] & 0xf0;
#else
        a = x[3] & 0xf0;
#endif
        if (a == 0x10) break;
        if (a < 0x10) {
            f = 0;
            *ux <<= 1;
            b -= 1;
        }
        else {
            if (*ux & 0x1) f = 1;
            else f = 0;
            *ux >>= 1;
            b += 1;
        }
    }
    if (f) {
        *ux += 1;
#if     FLTMPU
        a = x[0] & 0xf0;
#else
        a = x[3] & 0xf0;
#endif
        if (a != 0x10) {
            *ux >>= 1;
            b += 1;
        }
    }
    return(b);
}
