/*  Floating Point(Float) Calc Subroutine
        void a_tof(char *c,unsigned char *x);
        Copyright(c) 2007,  S.SAKAI     2007.3.5    */
#include    "fltmpu.h"

int     _numchk(char);
void    _fnorm2(unsigned char *,int,short *);

void a_tof(char *c,unsigned char *x)
{ int               i,exps,expe,sgn;
  short             *expx;
  unsigned char     fx[6];
  unsigned long     *ux,*ufx;

    ux = (unsigned long *)x;
    ufx = (unsigned long *)fx;
    expx = (short *)(fx+4);
    sgn = 0;
    expe = 0;
    exps = 0;
    *ufx = 0;
    *expx = 0x9b;

    i = 0;
    while(1) {
        if (_numchk(c[i])) {
#if     FLTMPU
            if (fx[0] == 0) {
#else
            if (fx[3] == 0) {
#endif
                *ufx *= 10;
                *ufx += (c[i] & 0xf);
                if (sgn & 0x2) exps--;
            }
            else {
                if ((sgn & 0x2) == 0) exps++;
            }
        }
        else if (c[i] == '.') {
            sgn |= 0x2;
        }
        else if (c[i] == '-') {
            sgn |= 0x1;
        }
        else if ((c[i] == 'e') || (c[i] == 'E') || (c[i] == 0)) {
            break;
        }
        i++;
    }

    if (*ufx == 0) {
        *ux = 0;
        return;
    }

    if (c[i]) {
        i++;
        while(1) {
            if (_numchk(c[i])) {
                expe *= 10;
                expe += (c[i] & 0xf);
            }
            else if (c[i] == '-') {
                sgn |= 0x4;
            }
            else if (c[i] == 0) break;
            i++;
        }
        if (sgn & 0x4) expe = -expe;
    }

    exps += expe;
    _fnorm2(fx,exps,expx);

    if (*expx < 0) *ufx = 0;
    else if (*expx >= 0x100)  {
        if (sgn & 0x1) *ufx = 0xffffffff;
        else *ufx = 0x7fffffff;
    }
    else {
        *expx <<= 7;
#if     FLTMPU
        fx[0] = fx[4];
        fx[1] &= 0x7f;
        fx[1] |= fx[5];
        if (sgn & 0x1) fx[0] |= 0x80;
#else
        fx[3] = fx[5];
        fx[2] &= 0x7f;
        fx[2] |= fx[4];
        if (sgn & 0x1) fx[3] |= 0x80;
#endif
    }
    *ux = *ufx;
}
