/*  Floating Point(Double) Calc Subroutine
        void d_add(unsigned char *x,unsigned char *y);
        Copyright(c) 2007,  S.SAKAI     2007.3.5    */
#include    "fltmpu.h"

int     _zrchkd(unsigned char *);
int     _dnorm(unsigned char *);
void    _danorm(unsigned char *,int);
void    _dnormshr(unsigned char *,int);
void    _dneg(unsigned char *);
int     _daddx(unsigned char *,unsigned char *,int);
int     _daddz(unsigned char *,unsigned char *);
void    d_mov(unsigned char *,unsigned char *);
int     _dnorma(unsigned char *);

void d_add(unsigned char *x,unsigned char *y)
{ int       a,b,j,k;
  unsigned char     f[8];

    if (_zrchkd(y) == 1) return;
    if (_zrchkd(x) == 1) {
        d_mov(x,y);
        return;
    }

    d_mov(f,y);
    a = _dnorm(x);
    b = _dnorm(f);

    j = a & 0x7ff;
    k = b & 0x7ff;

    if (j > k) {
        _dnormshr(f,j-k);
    }
    else if (j < k) {
        _dnormshr(x,k-j);
        if (a & 0x800) a = b | 0x800;
        else a = b & 0x7ff;
    }

    if (a & 0x800) _dneg(x);
    if (b & 0x800) _dneg(f);

    a = _daddx(x,f,a);
    if (_zrchkd(x)) return;

    _danorm(x,a);
}

int _daddx(unsigned char *x,unsigned char *y,int z)
{
    _daddz(x,y);

    if (_zrchkd(x)) return(z);
#if     FLTMPU
    if (x[0] & 0x80) {
#else
    if (x[7] & 0x80) {
#endif
        _dneg(x);
        z |= 0x800;
    }
    else z &= 0x7ff;

    z += _dnorma(x);
    return(z);
}
