/*  Floating Point(Double) Calc Subroutine
        void d_atn(unsigned char *x);
        Copyright(c) 2007,  S.SAKAI     2007.3.9    */
#include    "fltmpu.h"

void    d_pai(unsigned char *,int);
void    d_add(unsigned char *,unsigned char *);
void    d_sub(unsigned char *,unsigned char *);
void    d_mlt(unsigned char *,unsigned char *);
void    d_div(unsigned char *,unsigned char *);
void    d_sqr(unsigned char *);
void    i_tod(unsigned char *,int);
int     _dcmpxy(unsigned char *,unsigned char *);
int     d_mov(unsigned char *,unsigned char *);

void d_atn(unsigned char *x)
{ unsigned char     x2[8],a[8],b[8],c[8],t[8],k[8];
  unsigned long     *ua,*uk,*ut;
  int               f,i,sgn,tt;

    ua = (unsigned long *)a;
    uk = (unsigned long *)k;
    ut = (unsigned long *)t;

#if     FLTMPU
    *uk = 0x3ff00000;               /* k = 1 */
    *(uk+1) = 0;
#else
    *(uk+1) = 0x3ff00000;           /* k = 1 */
    *uk = 0;
#endif

    sgn= 0;
#if     FLTMPU
    if (x[0] & 0x80) {
        x[0] &= 0x7f;
#else
    if (x[7] & 0x80) {
        x[7] &= 0x7f;
#endif
        sgn = -1;
    }

    if (_dcmpxy(x,k) >= 0) {
        d_mov(a,x);
        d_sub(x,k);
        d_add(a,k);
        d_div(x,a);
        d_pai(t,4);
    }
    else {
        *(ut+1) = 0;
        *ut = 0;
    }

    tt = 1;
#if     FLTMPU
    *ua = 0x3fb99999;               /* a = 0.1 */
    *(ua+1) = 0x9999999a;
#else
    *(ua+1) = 0x3fb99999;           /* a = 0.1 */
    *ua = 0x9999999a;
#endif
    while (_dcmpxy(x,a) > 0) {
        d_mov(x2,x);
        d_mlt(x2,x);
        d_add(x2,k);
        d_sqr(x2);
        d_add(x2,k);
        d_div(x,x2);
        tt *= 2;
    }

    d_mov(b,x);
    d_mov(c,x);
    d_mov(x2,x);
    d_mlt(x2,x);

    f = 0;
    i = 1;
    *(ua+1) = 0;                    /* a = 0 */
    *ua = 0;
    while(1) {
        if (_dcmpxy(a,b) == 0) break;
        d_mov(b,a);
        if (f == 0) {
            d_add(a,c);
            f = 1;
        }
        else {
            d_sub(a,c);
            f = 0;
        }
        i += 2;
        d_mlt(x,x2);
        d_mov(c,x);
        i_tod(k,i);
        d_div(c,k);
    }
    i_tod(b,tt);
    d_mlt(a,b);
    d_add(a,t);
    if (sgn) {
#if     FLTMPU
        a[0] |= 0x80;
#else
        a[7] |= 0x80;
#endif
    }
    d_mov(x,a);
}
