/*  Floating Point(Double) Calc Subroutine
        void d_exp(unsigned char *x);
        Copyright(c) 2007,  S.SAKAI     2007.3.9    */
#include    "fltmpu.h"

int     _dcmpxy(unsigned char *,unsigned char *);
void    d_add(unsigned char *,unsigned char *);
void    d_mlt(unsigned char *,unsigned char *);
void    d_div(unsigned char *,unsigned char *);
int     _d_toi(unsigned char *);
void    d_frac(unsigned char *);
void    d_mov(unsigned char *,unsigned char *);
void    d_xchg(unsigned char *,unsigned char *);
void    i_tod(unsigned char *,int);
void    rddexp(unsigned char *,int);

void d_exp(unsigned char *x)
{ unsigned char     a[8],b[8],x2[8],y[8],k[8];
  int               i,m,n,sgn;
  unsigned long     *ua,*ux,*uy;

    ua = (unsigned long *)a;
    ux = (unsigned long *)x;
    uy = (unsigned long *)y;

    sgn = 0;
#if     FLTMPU
    if (x[0] & 0x80) {
        x[0] &= 0x7f;
#else
    if (x[7] & 0x80) {
        x[7] &= 0x7f;
#endif
        sgn = 1;
    }

    *uy = *ux;
    *(uy+1) = *(ux+1);
    d_frac(y);
    n = _d_toi(x);

#if     FLTMPU
    *ux = 0x3ff00000;                       /* x = 1 */
    *(ux+1) = 0;
#else
    *ux = 0;
    *(ux+1) = 0x3ff00000;                   /* x = 1 */
#endif

    if (n) {
        m = 512;
        i = 9;
        while(1) {
            if (n >= m) {
                rddexp(k,i);
                d_mlt(x,k);
                n -= m;
            }
            m /= 2;
            i--;
            if (i < 0) break;
        }
    }

    if ((*uy != 0) || (*(uy+1) != 0)) {
        i = 2;
#if     FLTMPU
        *(ua+1) = 0;
        *ua = 0x3ff00000;                   /* a = 1 */
#else
        *(ua+1) = 0x3ff00000;               /* a = 1 */
        *ua = 0;
#endif
        d_mov(b,y);
        d_mov(x2,y);
        while(1) {
            if (i > 25) break;
            if (_dcmpxy(a,b) == 0) break;
            d_mov(b,a);
            d_add(a,y);
            d_mlt(y,x2);
            i_tod(k,i++);
            d_div(y,k);
        }
        d_mlt(x,a);
    }
    if (sgn) {
#if     FLTMPU
        *(ua+1) = 0;
        *ua = 0x3ff00000;                   /* a = 1 */
#else
        *(ua+1) = 0x3ff00000;               /* a = 1 */
        *ua = 0;
#endif
        d_xchg(x,a);
        d_div(x,a);
    }
}
