/*  Floating Point(Double) Calc Subroutine
        void d_ln(unsigned char *x);
        Copyright(c) 2007,  S.SAKAI     2007.3.9    */
#include    "fltmpu.h"

int     _dcmpxy(unsigned char *,unsigned char *);
void    d_mov(unsigned char *,unsigned char *);
void    d_add(unsigned char *,unsigned char *);
void    d_sub(unsigned char *,unsigned char *);
void    d_mlt(unsigned char *,unsigned char *);
void    d_div(unsigned char *,unsigned char *);
void    i_tod(unsigned char *,int);
void    d_sqr(unsigned char *);
int     _zrchkd(unsigned char *);

void d_ln(unsigned char *x)
{ unsigned char     a[8],b[8],x2[8],k1[8],k2[8];
  int   i,j;
  unsigned long     *ux,*ua,*uk1,*uk2;

    ux = (unsigned long *)x;
    ua = (unsigned long *)a;
    uk1 = (unsigned long *)k1;
    uk2 = (unsigned long *)k2;

#if     FLTMPU
    if ((x[0] & 0x80) || (_zrchkd(x) == 1)) return;
    if ((*(ux+1) == 0) && (*ux == 0x3ff00000)) {
#else
    if ((x[7] & 0x80) || (_zrchkd(x) == 1)) return;
    if ((*ux == 0) && (*(ux+1) == 0x3ff00000)) {
#endif
        *ux = 0;
        *(ux+1) = 0;                /* x = 0 */
        return;
    }

#if     FLTMPU
    *uk1 = 0x3fe33333;              /* k1 = 0.6 */
    *(uk1+1) = 0x33333333;
    *uk2 = 0x3ffa6666;              /* k2 = 1.65 */
    *(uk2+1) = 0x66666666;
#else
    *(uk1+1) = 0x3fe33333;          /* k1 = 0.6 */
    *uk1 = 0x33333333;
    *(uk2+1) = 0x3ffa6666;          /* k2 = 1.65 */
    *uk2 = 0x66666666;
#endif

    i = 1;
    while(1) {
        if ((_dcmpxy(x,k1) >= 0) && (_dcmpxy(x,k2) <= 0)) break;
        d_sqr(x);
        i *= 2;
    }

    d_mov(x2,x);
#if     FLTMPU
    *uk1 = 0x3ff00000;              /* k1 = 1 */
    *(uk1+1) = 0;
#else
    *(uk1+1) = 0x3ff00000;          /* k1 = 1 */
    *uk1 = 0;
#endif
    d_sub(x,k1);
    d_add(x2,k1);
    d_div(x,x2);
    d_mov(b,x);
    d_mov(x2,x);
    d_mlt(x2,x);
    *(ua+1) = 0;                    /* a = 0 */
    *ua = 0;
    j = 1;
    while(1) {
        if (j > 30) break;
        if (_dcmpxy(a,b) == 0) break;
        d_mov(b,a);
        d_mov(k1,x);
        i_tod(k2,j);
        d_div(k1,k2);
        d_add(a,k1);
        d_mlt(x,x2);
        j += 2;
    }
    i_tod(k1,i*2);
    d_mlt(a,k1);
    d_mov(x,a);
}
