/*  Floating Point(Double) Calc Subroutine
        void d_pow(unsigned char *x,unsigned char *y);
            x^y = exp(y*ln(x));
        Copyright(c) 2007,  S.SAKAI     2007.3.9    */
#include    "fltmpu.h"

void    d_mlt(unsigned char *,unsigned char *);
void    d_ln(unsigned char *);
void    d_exp(unsigned char *);
int     _d_toi(unsigned char *);
void    d_frac(unsigned char *);

void d_pow(unsigned char *x,unsigned char *y)
{ unsigned char     a[8],b[8],c[8],f[8];
  int               n;
  unsigned long     *ua,*ub,*uc,*uf,*ux,*uy;

    ua = (unsigned long *)a;
    ub = (unsigned long *)b;
    uc = (unsigned long *)c;
    uf = (unsigned long *)f;
    ux = (unsigned long *)x;
    uy = (unsigned long *)y;

    *ua = *uy;
    *(ua+1) = *(uy+1);
    d_frac(a);
    n = _d_toi(y);

#if     FLTMPU
    *uf = 0x3ff00000;                       /* f = 1 */
    *(uf+1) = 0;
#else
    *uf = 0;
    *(uf+1) = 0x3ff00000;                   /* f = 1 */
#endif

    *uc = *ux;
    *(uc+1) = *(ux+1);
    if (n) {
        while(1) {
            if (n == 0) break;
            if (n & 0x1) d_mlt(f,c);
            *ub = *uc;
            *(ub+1) = *(uc+1);
            d_mlt(c,b);
            n >>= 1;
        }
    }

    if (a) {
        d_ln(x);
        d_mlt(x,a);
        d_exp(x);
    }
    d_mlt(x,f);
}
