/*  Floating Point(Double) Calc Subroutine
        void d_sqr(unsigned char *x);
        Copyright(c) 2007,  S.SAKAI     2007.3.7    */
#include    "fltmpu.h"

int     _zrchkd(unsigned char *);
void    d_mov(unsigned char *,unsigned char *);
void    i_tod(unsigned char *,int);
void    d_add(unsigned char *,unsigned char *);
void    d_div(unsigned char *,unsigned char *);
int     _dcmpxy(unsigned char *,unsigned char *);

void d_sqr(unsigned char *x)
{ unsigned char     a[8],b[8],c[8],z[8];
  unsigned long     *ux,*ua;
  unsigned short    *us;
  int               i,j;

    ux = (unsigned long *)x;
    ua = (unsigned long *)a;
    i_tod(c,2);

#if     FLTMPU
    if ((_zrchkd(x)) || (x[0] & 0x80)) return;
    if ((*ux == 0x7ff00000) && (*(ux+1) == 0x0)) return;

    i = x[0];
    i <<= 8;
    i |= x[1];
#else
    if ((_zrchkd(x)) || (x[7] & 0x80)) return;
    if ((*(ux+1) == 0x3ff00000) && (*ux == 0x0)) return;

    i = x[7];
    i <<= 8;
    i |= x[6];
#endif
    i >>= 4;
    j = i;
    i += 0x3ff;
    i /= 2;
    if (i == j) {
        if (j >= 0x3ff) i--;
        else i++;
    }
    d_mov(a,x);
#if     FLTMPU
    *ua &= 0xfffff;
    a[0] = i >> 4;
    a[1] |= i << 4;
#else
    *(ua+1) &= 0xfffff;
    a[7] = i >> 4;
    a[6] |= i << 4;
#endif

    d_mov(b,x);
    i = 16;
    while(1) {
        if (i-- == 0) break;
        if (_dcmpxy(a,b) == 0) break;
        d_mov(b,a);
        d_mov(z,x);
        d_div(z,a);
        d_add(z,a);
        d_div(z,c);
        d_mov(a,z);
    }
    d_mov(x,a);
}
