/*  Floating Point(Double) Calc Subroutine
        void d_toa(char *c,unsigned char *x,int n);
        Copyright(c) 2007,  S.SAKAI     2007.3.5    */
#include    "fltmpu.h"

int     _zrchkd(unsigned char *);
int     _regnormd(unsigned char *);
void    _btoad(char *,unsigned char *,int,int);
void    _mlt10d(unsigned char *);
void    _div10d(unsigned char *);
void    _regshld(unsigned char *);
void    _regshrd(unsigned char *);
void    _dnormshl(unsigned char *,int);
int     _round(char *,int,int);


/*      n < 0   x.yyyExx(y:n)
        n >= 0  xx.yyy(y:n)     */
void d_toa(char *c,unsigned char *x,int n)
{ int       i,r;
  short     *expx;
  unsigned char     fx[10];
  unsigned long     *ux,*uf;

    if (_zrchkd(x)) {
        i = 0;
        c[i++] = '0';
        if (n < 0) r = -n;
        else r = n;
        r--;
        if (r > 0) {
            c[i++] = '.';
            while(r--) c[i++] = '0';
        }
        if (n < 0) {
            c[i++] = 'E';
            c[i++] = '0';
        }
        c[i] = 0;
        return;
    }

    expx = (short *)(fx+8);
    ux = (unsigned long *)x;
    uf = (unsigned long *)fx;
    *uf = *ux;
    *(uf+1) = *(ux+1);
#if     FLTMPU
    i = *(short *)x;
#else
    i = *(short *)(x+6);
#endif
    i >>= 4;
    *expx = i & 0x7ff;
#if     FLTMPU
    *uf &= 0xfffff;
    *uf |= 0x100000;
#else
    *(uf+1) &= 0xfffff;
    *(uf+1) |= 0x100000;
#endif
    r = _regnormd(fx);
#if     FLTMPU
    fx[8] |= x[0] & 0x80;
#else
    fx[9] |= x[7] & 0x80;
#endif
    _btoad(c,fx,r,n);
}

int _regnormd(unsigned char *x)
{ int       a,r;
  short     *expx;
  unsigned short    *us;
  unsigned long     *ul;

    expx = (short *)(x+8);
#if     FLTMPU
    us = (unsigned short *)x;
#else
    us = (unsigned short *)(x+6);
#endif
    r = 0;
    _dnormshl(x,8);
    while (1) {
        if (*expx == 0x3ff) break;
        if (*expx > 0x3ff) {
            while (1) {
                a = *us;
                if (a > 0x7fff) {
                    _div10d(x);
                    r++;
                    if (*expx == 0x3ff) break;
                }
                else {
                    _regshld(x);
                    (*expx)--;
                }
                a = *us;
                if ((*expx == 0x3ff) && (a <= 0x9fff)) break;
            }
        }
        else {
            while (1) {
                a = *us;
                if (a < 0x1000) {
                    _mlt10d(x);
                    r--;
                    a = *us;
                    if ((*expx == 0x3ff) && (a <= 0x9fff)) break;
                }
                _regshrd(x);
                (*expx)++;
                a = *us;
                if ((*expx == 0x3ff) && ((a <= 0x9fff) && (a >= 0x1000))) break;
            }
        }
    }

    ul = (unsigned long *)x;
#if     FLTMPU
    *(ul+1) += 1;
    if (*(ul+1) == 0) *ul += 1;
#else
    *ul += 1;
    if (*ul == 0) *(ul+1) += 1;
#endif
    return(r);
}

void _btoad(char *c,unsigned char *x,int n,int m)
{ int   i,nn;
  unsigned long     a;

    if (m == 0) m = 1;
    if (m < 0) nn = -m;
    else nn = m - 1;

    i = 0;
#if     FLTMPU
    if (x[8] & 0x80) c[i] = '-';
#else
    if (x[9] & 0x80) c[i] = '-';
#endif
    else c[i] ='+';
    i++;
    if (m < 0) {
        while (1) {
            if ((i == 2) && (nn != 0)) c[i++] = '.';
            if (nn-- == 0) break;
#if     FLTMPU
            a = x[0];
#else
            a = x[7];
#endif
            a >>= 4;
            a |= 0x30;
            c[i++] = a;
#if     FLTMPU
            x[0] &= 0xf;
#else
            x[7] &= 0xf;
#endif
            _mlt10d(x);
        }

#if     FLTMPU
        if ((x[0] > 0x4f) || ((x[0] == 0x4f) && (x[1] == 0xff))) n += _round(c,i,1);
#else
        if ((x[7] > 0x4f) || ((x[7] == 0x4f) && (x[6] == 0xff))) n += _round(c,i,1);
#endif

        c[i++] = 'E';
        if (n < 0) {
            c[i++] = '-';
            n = -n;
        }

        a = 0;
        c[i] = (n / 100) | 0x30;
        n %= 100;
        if (c[i] != '0') {
            a++;
            i++;
        }
        c[i] = (n / 10) | 0x30;
        if ((c[i] != '0') || (a != 0)) i++;
        c[i++] = (n % 10) | 0x30;
        c[i] = 0;
    }
    else {
        if (n >= 0) {
            while (1) {
#if     FLTMPU
                a = x[0];
#else
                a = x[7];
#endif
                a >>= 4;
                a |= 0x30;
                c[i++] = a;
#if     FLTMPU
                x[0] &= 0xf;
#else
                x[7] &= 0xf;
#endif
                _mlt10d(x);
                if ((n == 0) && (nn <= 0)) break;
                if ((nn-- == 0) && (n <= 0))  break;
                if (n-- == 0) c[i++] = '.';
            }
            c[i] = 0;
        }
        else {
            c[i++] ='0';
            n++;
            c[i++] = '.';
            while(1) {
                if (n == 0) break;
                if (nn-- == 0) break;
                c[i++] ='0';
                n++;
            }
            if (nn > 0) {
                while (nn--) {
#if     FLTMPU
                    a = x[0];
#else
                    a = x[7];
#endif
                    a >>= 4;
                    a &= 0xf;
                    a |= 0x30;
                    c[i++] = a;
#if     FLTMPU
                    x[0] &= 0xf;
#else
                   x[7] &= 0xf;
#endif
                    _mlt10d(x);
                }
            }
            c[i] = 0;
        }

#if     FLTMPU
        if ((x[0] > 0x4f) || ((x[0] == 0x4f) && (x[6] == 0xff))) _round(c,i,0);
#else
        if ((x[7] > 0x4f) || ((x[7] == 0x4f) && (x[6] == 0xff))) _round(c,i,0);
#endif
    }
}

