/*  Floating Point Calc Subroutine
        void d_tof(unsigned char *x,unsigned char *y);
        Copyright(c) 2007,  S.SAKAI     2007.3.6    */
#include    "fltmpu.h"

/*      x[3]..x[0] <- y[7]..y[0]   */
void d_tof(unsigned char *x,unsigned char *y)
{ unsigned long     *ux;
  int               a,i;

    ux = (unsigned long *)x;

#if     FLTMPU
    a = *(unsigned short *)y;
#else
    a = *(unsigned short *)(y+6);
#endif
    a >>= 4;
    a &= 0x7ff;
    a -= 0x3ff;
    a += 0x7f;
    if (a < 0) {
        *ux = 0;
        return;
    }
    if (a > 0xff) {
        *ux = 0x7fffffff;
#if     FLTMPU
        if (y[0] & 0x80) x[0] |= 0x80;
#else
        if (y[7] & 0x80) x[3] |= 0x80;
#endif
        return;
    }

#if     FLTMPU
    for (i=0;i<4;i++) x[i] = y[i+1];
    x[0] = y[1] & 0xf;
#else
    for (i=0;i<4;i++) x[i] = y[i+3];
    x[3] = y[6] & 0xf;
#endif

    if ((*ux & 0xffffff0) == 0xffffff0) {
        *ux = 0;
        a += 1;
    }
    else {
        *ux += 0x10;
        *ux >>= 5;
    }
#if     FLTMPU
    if (a & 1) x[1] |= 0x80;
#else
    if (a & 1) x[2] |= 0x80;
#endif
    a >>= 1;
#if     FLTMPU
    x[0] = a;
    if (y[0] & 0x80) x[0] |= 0x80;
#else
    x[3] = a;
    if (y[7] & 0x80) x[3] |= 0x80;
#endif
}
