/*  Floating Point(Double) Calc Subroutine
        int _d_toi(unsigned char *x);   kirisute
        int d_toi(unsigned char *x);    4sha5nyu
        int dtou(unsigned char *x);     4sha5nyu
        Copyright(c) 2007,  S.SAKAI     2007.3.6    */
#include    "fltmpu.h"

int     dtox(unsigned char *,int);
int     _zrchkd(unsigned char *);
void    d_mov(unsigned char *,unsigned char *);
int     _regnormd(unsigned char *);
void    _mlt10d(unsigned char *);


int _d_toi(unsigned char *x)
{
    return(dtox(x,-1));
}

int d_toi(unsigned char *x)
{
    return(dtox(x,0));
}

int d_tou(unsigned char *x)
{
    return(dtox(x,1));
}

int dtox(unsigned char *x,int n)
{ unsigned char     fx[10];
  unsigned long     *ux,*uf;
  int               a,b,r;

    a = 0;
    uf = (unsigned long *)fx;

    if (_zrchkd(x)) return(a);
#if     FLTMPU
    if ((n > 0) && (x[0] & 0x80)) {
#else
    if ((n > 0) && (x[7] & 0x80)) {
#endif
        return(a);
    }

    d_mov(fx,x);
#if     FLTMPU
    r = *(short *)x;
#else
    r = *(short *)(x+6);
#endif
    r >>= 4;
    r &= 0x7ff;
#if     FLTMPU
    *uf &= 0xfffff;
    *uf |= 0x100000;
    fx[9] = r;
    fx[8] = r >> 8;
#else
    *(uf+1) &= 0xfffff;
    *(uf+1) |= 0x100000;
    fx[8] = r;
    fx[9] = r >> 8;
#endif
    r = _regnormd(fx);
#if     FLTMPU
    if (n <= 0) fx[8] |= x[0] & 0x80;
#else
    if (n <= 0) fx[9] |= x[7] & 0x80;
#endif

    if (r >= -1) {
        if (r >= 0) {
            while (1) {
#if     FLTMPU
                b = fx[0];
#else
                b = fx[7];
#endif
                b >>= 4;
                a = a * 10 + b;
#if     FLTMPU
                fx[0] &= 0xf;
#else
                fx[7] &= 0xf;
#endif
                _mlt10d(fx);
                if (r == 0) break;
                r--;
            }
            if (n >= 0) {
#if     FLTMPU
                b = fx[0];
#else
                b = fx[7];
#endif
                b >>= 4;
                if (b > 4) a += 1;
            }
        }
        else {
            if (n >= 0) {
#if     FLTMPU
                a = fx[0];
#else
                a = fx[7];
#endif
                a >>= 4;
                if (a >= 5) a = 1;
                else a = 0;
            }
            else a = 0;
        }
#if     FLTMPU
        if ((n <= 0) && (fx[8] & 0x80)) {
#else
        if ((n <= 0) && (fx[9] & 0x80)) {
#endif
            a = -a;
        }
    }
    return(a);
}
