/*  Floating Point(Double) Calc Subroutines
        Copyright(c) 2007,  S.SAKAI     2007.4.24   */
#include    "fltmpu.h"

void    _dnormshl(unsigned char *,int);
void    _mlt10d(unsigned char *);
void    _div10d(unsigned char *);
void    _regshrd(unsigned char *);
void    _regdp1(unsigned char *);
int     _dnormb(unsigned char *);


/*      x[7]..x[0] Normalize  x[9]x[8]++;   */
void _regm10d(unsigned char *x)
{ short *expx;

    expx = (short *)(x+8);
    _mlt10d(x);
    *expx += _dnormb(x);
}

/*      x[7]..x[0] Normalize  x[9]x[8]--;   */
void _regd10d(unsigned char *x)
{ short *expx;

    expx = (short *)(x+8);
    _dnormshl(x,3);
    *expx -= 3;
    _div10d(x);
    *expx += _dnormb(x);
}

void _dnorm2(unsigned char *x,int es,short *ex)
{ unsigned long     *ux;
  int       f;

    *ex += _dnormb(x);
    while (es) {
        if (es > 0) {
            _regm10d(x);
            es--;
        }
        else {
            _regd10d(x);
            es++;
        }
        if (es == 0) break;
    }

    ux = (unsigned long *)x;
    while(1) {
#if     FLTMPU
        f = x[7] & 0x1;
#else
        f = x[0] & 0x1;
#endif
        _regshrd(x);
#if     FLTMPU
        if ((*ux & 0xfff00000) == 0x100000) {
#else
        if ((*(ux+1) & 0xfff00000) == 0x100000) {
#endif
            break;
        }
    }
    if (f) {
        _regdp1(x);
#if     FLTMPU
        if ((*ux & 0xfff00000) != 0x100000) {
#else
        if ((*(ux+1) & 0xfff00000) != 0x100000) {
#endif
            _regshrd(x);
            *ex += 1;
        }
    }
}
