/*  Floating Point(Float) Calc Subroutine
        void f_add(unsigned char *x,unsigned char *y);
        Copyright(c) 2007,  S.SAKAI     2007.3.5    */
#include    "fltmpu.h"

int     _fnorm(unsigned char *);
int     _fanorm(unsigned char *,int);
int     _faddx(unsigned char *,unsigned char *,int);
int     _fnorma(unsigned char *);

void f_add(unsigned char *x,unsigned char *y)
{ int   a,b,j,k,r,i;
  unsigned char     f[4];
  unsigned long     *ux,*uy,*uf;

    ux = (unsigned long *)x;
    uy = (unsigned long *)y;
    uf = (unsigned long *)f;

    if (*uy == 0) return;
    if (*ux == 0) {
        *ux = *uy;
        return;
    }

    *uf = *uy;
    a = _fnorm(x);
    b = _fnorm(f);
    j = a & 0xff;
    k = b & 0xff;

    if (j > k) {
        if ((j-k) > 32) *uf = 0;
        else if ((j-k) == 32) {
            if (*uf & 0x80000000) *uf = 1;
            else *uf = 0;
        }
        else {
            *uf >>= (j-k-1);
            *uf += 1;
            *uf >>= 1;
        }
    }
    else if (j < k) {
        if ((k-j) > 32) *ux = 0;
        else if ((k-j) == 32) {
            if (*ux & 0x80000000) *ux = 1;
            else *ux = 0;
        }
        else {
            *ux >>= (k-j-1);
            *ux += 1;
            *ux >>= 1;
        }
        if (a & 0x100) a = b | 0x100;
        else a = b & 0xff;
    }

    if (a & 0x100) *ux = 0 - *ux;
    if (b & 0x100) *uf = 0 - *uf;

    a = _faddx(x,f,a);
    if (*ux == 0) return;

    _fanorm(x,a);
}

int _faddx(unsigned char *x,unsigned char *y,int z)
{ int   a,b;
  int   f;
  unsigned long *ux,*uy;

    ux = (unsigned long *)x;
    uy = (unsigned long *)y;
    *ux += *uy;

    if (*ux == 0) return(z);
#if     FLTMPU
    if (x[0] & 0x80) {
#else
    if (x[3] & 0x80) {
#endif
        *ux = 0 - *ux;
        z |= 0x100;
    }
    else z &= 0xff;

    z += _fnorma(x);
    return(z);
}

