/*  Floating Point(Float) Calc Subroutine
        void f_atn(unsigned char *x);
        Copyright(c) 2007,  S.SAKAI     2007.3.9    */
#include    "fltmpu.h"

void    f_pai(unsigned char *,int);
void    f_add(unsigned char *,unsigned char *);
void    f_sub(unsigned char *,unsigned char *);
void    f_mlt(unsigned char *,unsigned char *);
void    f_div(unsigned char *,unsigned char *);
void    f_sqr(unsigned char *);
void    i_tof(unsigned char *,int);

void f_atn(unsigned char *x)
{ unsigned char     x2[4],a[4],b[4],c[4],t[4],k[4];
  unsigned long     *ux,*ux2,*ua,*ub,*uc,*uk,*ut;
  int               f,i,sgn,tt;

    ux = (unsigned long *)x;
    ux2 = (unsigned long *)x2;
    ua = (unsigned long *)a;
    ub = (unsigned long *)b;
    uc = (unsigned long *)c;
    uk = (unsigned long *)k;
    ut = (unsigned long *)t;

    *uk = 0x3f800000;               /* k = 1 */

    sgn= 0;
#if     FLTMPU
    if (x[0] & 0x80) {
        x[0] &= 0x7f;
#else
    if (x[3] & 0x80) {
        x[3] &= 0x7f;
#endif
        sgn = -1;
    }

    if (*ux >= *uk) {
        *ua = *ux;
        f_sub(x,k);
        f_add(a,k);
        f_div(x,a);
        f_pai(t,4);
    }
    else *ut = 0;

    tt = 1;
    *ua = 0x3dcccccd;               /* a = 0.1 */
    while (*ux > *ua) {
        *ux2 = *ux;
        f_mlt(x2,x);
        f_add(x2,k);
        f_sqr(x2);
        f_add(x2,k);
        f_div(x,x2);
        tt *= 2;
    }

    *ub = *ux;
    *uc = *ux;
    *ux2 = *ux;
    f_mlt(x2,x);

    f = 0;
    i = 1;
    *ua = 0;
    while(1) {
        if (*ua == *ub) break;
        *ub = *ua;
        if (f == 0) {
            f_add(a,c);
            f = 1;
        }
        else {
            f_sub(a,c);
            f = 0;
        }
        i += 2;
        f_mlt(x,x2);
        *uc = *ux;
        i_tof(k,i);
        f_div(c,k);
    }
    i_tof(b,tt);
    f_mlt(a,b);
    f_add(a,t);
    if (sgn) {
#if     FLTMPU
        a[0] |= 0x80;
#else
        a[3] |= 0x80;
#endif
    }
    *ux = *ua;
}
