/*  Floating Point(Float) Calc Subroutine
        void f_cos(unsigned char *x);
        Copyright(c) 2007,  S.SAKAI     2007.3.7    */
#include    "fltmpu.h"

void    f_pai(unsigned char *,int);
void    f_neg(unsigned char *);
void    f_sub(unsigned char *,unsigned char *);
void    _fnfsinx(unsigned char *);
void    _fnfcosx(unsigned char *);

void f_cos(unsigned char *x)
{ unsigned char     p[4],p2[4],ph[4],pq[4],p1h[4];
  int   sgn;
  unsigned long     *ux,*up,*up2,*uph,*upq,*up1h;

    ux = (unsigned long *)x;
    up = (unsigned long *)p;
    up2 = (unsigned long *)p2;
    uph = (unsigned long *)ph;
    upq = (unsigned long *)pq;
    up1h = (unsigned long *)p1h;

    f_pai(p,0);
    f_pai(p2,1);
    f_pai(ph,2);
    f_pai(pq,4);
    f_pai(p1h,5);

    sgn = 0;
#if     FLTMPU
    if (x[0] & 0x80) {
#else
    if (x[3] & 0x80) {
#endif
        f_neg(x);
    }

    while(1) {
        if (*ux <= *up2) break;
        f_sub(x,p2);
    }
    if (*ux > *up1h) {
        f_sub(x,p2);
        f_neg(x);
    }
    else if (*ux > *up) {
        sgn = ~sgn;
        f_sub(x,p);
    }
    else if (*ux > *uph) {
        sgn = ~sgn;
        f_sub(x,p);
        f_neg(x);
    }

    if (*ux > *upq) {
        f_sub(x,ph);
        f_neg(x);
        _fnfsinx(x);
    }
    else _fnfcosx(x);

    if (sgn) f_neg(x);
}
