/*  Floating Point(Double) Calc Subroutine
        void f_exp(unsigned char *x);
        Copyright(c) 2007,  S.SAKAI     2007.3.9    */
#include    "fltmpu.h"

void    f_add(unsigned char *,unsigned char *);
void    f_mlt(unsigned char *,unsigned char *);
void    f_div(unsigned char *,unsigned char *);
int     _f_toi(unsigned char *);
void    f_frac(unsigned char *);
void    f_xchg(unsigned char *,unsigned char *);
void    i_tof(unsigned char *,int);
void    rdfexp(unsigned char *,int);

void f_exp(unsigned char *x)
{ unsigned char     a[4],b[4],k[4],x2[4],y[4];
  int               i,m,n,sgn;
  unsigned long     *ua,*ub,*ux,*ux2,*uy;

    ua = (unsigned long *)a;
    ub = (unsigned long *)b;
    ux = (unsigned long *)x;
    ux2 = (unsigned long *)x2;
    uy = (unsigned long *)y;

    sgn = 0;
#if     FLTMPU
    if (x[0] & 0x80) {
        x[0] &= 0x7f;
#else
    if (x[3] & 0x80) {
        x[3] &= 0x7f;
#endif
        sgn = 1;
    }

    *uy = *ux;
    f_frac(y);
    n = _f_toi(x);
    *ux = 0x3f800000;                   /* x = 1; */
    if (n) {
        m = 64;
        i = 6;
        while(1) {
            if (n >= m) {
                rdfexp(k,i);
                f_mlt(x,k);
                n -= m;
            }
            m /= 2;
            i--;
            if (i < 0) break;
        }
    }

    if (*uy) {
        i = 2;
        *ua = 0x3f800000;           /* a = 1 */
        *ub = *uy;
        *ux2 = *uy;
        while(1) {
            if (i > 25) break;
            if (*ua == *ub) break;
            *ub = *ua;
            f_add(a,y);
            f_mlt(y,x2);
            i_tof(k,i++);
            f_div(y,k);
        }
        f_mlt(x,a);
    }

    if (sgn) {
        *ua = 0x3f800000;
        f_xchg(x,a);
        f_div(x,a);
    }
}
