/*  Floating Point(Float) Calc Subroutine
        void f_ln(unsigned char *x);
        Copyright(c) 2007,  S.SAKAI     2007.3.9    */
#include    "fltmpu.h"

void    f_add(unsigned char *,unsigned char *);
void    f_sub(unsigned char *,unsigned char *);
void    f_mlt(unsigned char *,unsigned char *);
void    f_div(unsigned char *,unsigned char *);
void    i_tof(unsigned char *,int);
void    f_sqr(unsigned char *);

void f_ln(unsigned char *x)
{ unsigned char     a[4],b[4],x2[4],k1[4],k2[4];
  int   i,j;
  unsigned long     *ux,*ux2,*ua,*ub,*uk1,*uk2;

    ux = (unsigned long *)x;
    ux2 = (unsigned long *)x2;
    ua = (unsigned long *)a;
    ub = (unsigned long *)b;
    uk1 = (unsigned long *)k1;
    uk2 = (unsigned long *)k2;

#if     FLTMPU
    if ((x[0] & 0x80) || (*ux == 0)) return;
#else
    if ((x[3] & 0x80) || (*ux == 0)) return;
#endif
    if (*ux == 0x3f800000) {
        *ux = 0;                    /* x = 0 */
        return;
    }

    *uk1 = 0x3f19999a;              /* k1 = 0.6 */
    *uk2 = 0x3fd33333;              /* k2 = 1.65 */
    i = 1;
    while(1) {
        if ((*ux >= *uk1) && (*ux <= *uk2)) break;
        f_sqr(x);
        i *= 2;
    }

    *ux2 = *ux;
    *uk1 = 0x3f800000;              /* k1 = 1 */
    f_sub(x,k1);
    f_add(x2,k1);
    f_div(x,x2);
    *ub = *ux;
    *ux2 = *ux;
    f_mlt(x2,x);
    *ua = 0;                        /* a = 0 */
    j = 1;
    while(1) {
        if (j > 20) break;
        if (*ua == *ub) break;
        *ub = *ua;
        *uk1 = *ux;
        i_tof(k2,j);
        f_div(k1,k2);
        f_add(a,k1);
        f_mlt(x,x2);
        j += 2;
    }
    i_tof(k1,i*2);
    f_mlt(a,k1);
    *ux = *ua;
}

