/*  Floating Point(Float) Calc Subroutine
        void f_pow(unsigned char *x,unsigned char *y);
            x^y = exp(y*ln(x));
        Copyright(c) 2007,  S.SAKAI     2007.3.9    */

void    f_mlt(unsigned char *,unsigned char *);
void    f_ln(unsigned char *);
void    f_exp(unsigned char *);
void    f_frac(unsigned char *);
int     _f_toi(unsigned char *);

void f_pow(unsigned char *x,unsigned char *y)
{ unsigned char     a[4],b[4],c[4],f[4];
  int               n;
  unsigned long     *ua,*ub,*uc,*uf,*ux,*uy;

    ua = (unsigned long *)a;
    ub = (unsigned long *)b;
    uc = (unsigned long *)c;
    uf = (unsigned long *)f;
    ux = (unsigned long *)x;
    uy = (unsigned long *)y;

    *ua = *uy;
    f_frac(a);
    n = _f_toi(y);
    *uf = 0x3f800000;                   /* f = 1; */
    *uc = *ux;
    if (n) {
        while(1) {
            if (n == 0) break;
            if (n & 0x1) f_mlt(f,c);
            *ub = *uc;
            f_mlt(c,b);
            n >>= 1;
        }
    }

    if (*ua) {
        f_ln(x);
        f_mlt(x,a);
        f_exp(x);
    }
    else *ux = 0x3f800000;              /* x = 1; */

    f_mlt(x,f);
}
