/*  Floating Point(Float) Calc Subroutine
        void f_pow10(unsigned char *x);
            10^x = exp(x*ln(10));
        Copyright(c) 2007,  S.SAKAI     2007.3.9    */

void    f_mlt(unsigned char *,unsigned char *);
void    f_div(unsigned char *,unsigned char *);
void    rdfpow(unsigned char *,int);

void f_pow10(unsigned char *x,int n)
{ unsigned char     a[4];
  unsigned long     *ux;
  int               i,m;

    ux = (unsigned long *)x;
    if (n < -38) *ux = 0;
    else if (n > 38) *ux = 0x7fffffff;
    else {
        *ux = 0x3f800000;
        if (n > 0) {
            m = 32;
            i = 6;
            while(1) {
                if (n >= m) {
                    rdfpow(a,i);
                    f_mlt(x,a);
                    n -= m;
                }
                m /= 2;
                i--;
                if (i < 0) break;
            }
        }
        else if (n < 0) {
            n = -n;
            m = 32;
            i = 6;
            while(1) {
                if (n >= m) {
                    rdfpow(a,i);
                    f_div(x,a);
                    n -= m;
                }
                m /= 2;
                i--;
                if (i < 0) break;
            }
        }
    }
}
