/*  Floating Point(Float) Calc Subroutine
        void f_sqr(unsigned char *x);
        Copyright(c) 2007,  S.SAKAI     2007.3.7    */
#include    "fltmpu.h"

void    i_tof(unsigned char *,int);
void    f_add(unsigned char *,unsigned char *);
void    f_div(unsigned char *,unsigned char *);

void f_sqr(unsigned char *x)
{ unsigned char     a[4],b[4],c[4],z[4];
  unsigned long     *ux,*uz,*ua,*ub;
  int               i,j;

    ux = (unsigned long *)x;
    uz = (unsigned long *)z;
    ua = (unsigned long *)a;
    ub = (unsigned long *)b;
    i_tof(c,2);

#if     FLTMPU
    if ((*ux == 0) || (x[0] & 0x80) || (*ux == 0x3f800000)) return;

    i = x[0];
    i <<= 8;
    i |= x[1];
#else
    if ((*ux == 0) || (x[3] & 0x80) || (*ux == 0x3f800000)) return;

    i = x[3];
    i <<= 8;
    i |= x[2];
#endif
    i >>= 7;
    j = i;
    i += 0x7f;
    i /= 2;
    if (i == j) {
        if (j >= 0x3f) i--;
        else i++;
    }
    *ua = *ux;
    *ua &= 0x7fffff;
#if     FLTMPU
    a[0] = i >> 1;
    if (i & 0x1) a[1] |= 0x80;
#else
    a[3] = i >> 1;
    if (i & 0x1) a[2] |= 0x80;
    else a[2] &= 0x7f;
#endif

    *ub = *ux;
    i = 16;
    while(1) {
        if (i-- == 0) break;
        if (*ua == *ub) break;
        *ub = *ua;
        *uz = *ux;
        f_div(z,a);
        f_add(z,a);
        f_div(z,c);
        *ua = *uz;
    }
    *ux = *ua;
}
