/*  Floating Point(Float) Calc Subroutine
        void f_toa(char *c,unsigned char *x);
        Copyright(c) 2007,  S.SAKAI     2007.3.5    */
#include    "fltmpu.h"

int     _regnormf(unsigned char *);
void    _btoaf(char *,unsigned char *,int,int);
int     _round(char *,int,int);

/*      n < 0   xx.xExx
        n >= 0  xx.yyy(y:n)     */
void f_toa(char *c,unsigned char *x,int n)
{ int       i,r;
  short     *expx;
  unsigned char     fx[6];
  unsigned long     *ux,*ufx;

    ux = (unsigned long *)x;
    ufx = (unsigned long *)fx;
    if (*ux == 0) {
        i = 0;
        c[i++] = '0';
        if (n < 0) r = -n;
        else r = n;
        r--;
        if (r > 0) {
            c[i++] = '.';
            while(r--) c[i++] = '0';
        }
        if (n < 0) {
            c[i++] = 'E';
            c[i++] = '0';
        }
        c[i] = 0;
        return;
    }

    *ufx = *ux;
    expx = (short *)(fx+4);
#if     FLTMPU
    i = *(short *)x;
#else
    i = *(short *)(x+2);
#endif
    i >>= 7;
    i &= 0xff;
    *expx = i;
#if     FLTMPU
    fx[0] = 0;
    fx[1] |= 0x80;
#else
    fx[3] = 0;
    fx[2] |= 0x80;
#endif

    r = _regnormf(fx);
#if     FLTMPU
    fx[4] |= x[0] & 0x80;
#else
    fx[5] |= x[3] & 0x80;
#endif
    _btoaf(c,fx,r,n);
}

int _regnormf(unsigned char *x)
{ short     *expx;
  int       a,f,r,z;
  unsigned long *ux;

    ux = (unsigned long *)x;
    expx = (short *)(x+4);
    r = 0;
    *ux <<= 5;
    while (1) {
        if (*expx == 0x7f) break;
        if (*expx > 0x7f) {
            while (1) {
#if     FLTMPU
                a = x[0];
#else
                a = x[3];
#endif
                if (a > 0x7f) {
                    *ux = (*ux + 5) / 10;
                    r++;
                    if (*expx == 0x7f) break;
                }
                else {
                    *ux <<= 1;
                    (*expx)--;
                }
#if     FLTMPU
                a = x[0];
#else
                a = x[3];
#endif
                if ((*expx == 0x7f) && (a <= 0x9f)) break;
            }
        }
        else {
            while (1) {
#if     FLTMPU
                a = x[0];
#else
                a = x[3];
#endif
                if (a < 0x10) {
                    *ux *= 10;
                    r--;
#if     FLTMPU
                    a = x[0];
#else
                    a = x[3];
#endif
                    if ((*expx == 0x7f) && (a <= 0x9f)) break;
                }
#if     FLTMPU
                f = x[3] & 0x1;
#else
                f = x[0] & 0x1;
#endif
                *ux >>= 1;
                (*expx)++;
#if     FLTMPU
                a = x[0];
#else
                a = x[3];
#endif
                if ((*expx == 0x7f) && ((a <= 0x9f) && (a >= 0x10))) break;
            }
            if (f) (*ux)++;
        }
    }
    return(r);
}

void _btoaf(char *c,unsigned char *x,int n,int m)
{ int               i,nn;
  unsigned long     *ux,a;

    ux = (unsigned long *)x;
    if (m == 0) m = 1;
    if (m < 0) nn = -m;
    else nn = m - 1;

    i = 0;
#if     FLTMPU
    if (x[4] & 0x80) c[i] = '-';
#else
    if (x[5] & 0x80) c[i] = '-';
#endif
    else c[i] ='+';
    i++;
    if (m < 0) {
        while (1) {
            if ((i == 2) && (nn != 0)) c[i++] = '.';
            if (nn-- == 0) break;
#if     FLTMPU
            a = x[0];
#else
            a = x[3];
#endif

            a >>= 4;
            a |= 0x30;
            c[i++] = a;
#if     FLTMPU
            x[0] &= 0xf;
#else
            x[3] &= 0xf;
#endif
            *ux *= 10;
        }
#if     FLTMPU
        if ((x[0] > 0x4f) || ((x[0] == 0x4f) && (x[1] == 0xff))) n += _round(c,i,1);
#else
        if ((x[3] > 0x4f) || ((x[3] == 0x4f) && (x[2] == 0xff))) n += _round(c,i,1);
#endif
        c[i++] = 'E';
        if (n < 0) {
            c[i++] = '-';
            n = -n;
        }

        c[i] = (n / 10) | 0x30;
        if (c[i] != '0') i++;
        c[i++] = (n % 10) | 0x30;
        c[i] = 0;
    }
    else {
        if (n >= 0) {
            while (1) {
#if     FLTMPU
                a = x[0];
#else
                a = x[3];
#endif
                a >>= 4;
                a |= 0x30;
                c[i++] = a;
#if     FLTMPU
                x[0] &= 0xf;
#else
                x[3] &= 0xf;
#endif
                *ux *= 10;
                if ((n == 0) && (nn <= 0)) break;
                if ((nn-- == 0) && (n <= 0))  break;
                if (n-- == 0) c[i++] = '.';
            }
            c[i] = 0;
        }
        else {
            c[i++] ='0';
            n++;
            c[i++] = '.';
            while(1) {
                if (n == 0) break;
                if (nn-- == 0) break;
                c[i++] ='0';
                n++;
            }
            if (nn > 0) {
                while (nn--) {
#if     FLTMPU
                    a = x[0];
#else
                    a = x[3];
#endif
                    a >>= 4;
                    a |= 0x30;
                    c[i++] = a;
#if     FLTMPU
                    x[0] &= 0xf;
#else
                    x[3] &= 0xf;
#endif
                    *ux *= 10;
                }
            }
            c[i] = 0;
        }

#if     FLTMPU
        if ((x[0] > 0x4f) || ((x[0] == 0x4f) && (x[1] == 0xff))) _round(c,i,0);
#else
        if ((x[3] > 0x4f) || ((x[3] == 0x4f) && (x[2] == 0xff))) _round(c,i,0);
#endif

    }
}
