/*  Floating Point Calc Subroutine
        void f_tod(unsigned char *x,unsigned char *y);
        Copyright(c) 2007,  S.SAKAI     2007.3.6    */
#include    "fltmpu.h"

void    _dnormshr(unsigned char *,int);

/*      x[7]..x[0] <- y[3]..y[0]   */
void f_tod(unsigned char *x,unsigned char *y)
{ unsigned long     *ux,*uy,*uf;
  unsigned short    *us;
  int               a;

    ux = (unsigned long *)x;
    uy = (unsigned long *)y;
#if     FLTMPU
    us = (unsigned short *)y;
#else
    us = (unsigned short *)(y+2);
#endif
    if (*uy == 0) {
        *ux = 0;
        *(ux+1) = 0;
    }
    else {
        a = *us;
        a >>= 7;
        a &= 0xff;
        a -= 0x7f;
        a += 0x3ff;
        a <<= 4;
#if     FLTMPU
        if (y[0] & 0x80) a |= 0x8000;

        *ux = *uy;
        *(ux+1) = 0;
#else
        if (y[3] & 0x80) a |= 0x8000;

        *(ux+1) = *uy;
        *ux = 0;
#endif
        _dnormshr(x,3);
#if     FLTMPU
        *ux &= 0x7fffff;
        x[1] |= a;
        x[0] = a >> 8;
#else
        *(ux+1) &= 0x7fffff;
        x[6] |= a;
        x[7] = a >> 8;
#endif
    }
}
