/*  Floating Point(Float) Calc Subroutine
        int _f_toi(unsigned char *x);   kirisute
        int f_toi(unsigned char *x);    4sha5nyu
        int f_tou(unsigned char *x);    4sha5nyu
        Copyright(c) 2007,  S.SAKAI     2007.3.6    */
#include    "fltmpu.h"

int     ftox(unsigned char *,int);
int     _regnormf(unsigned char *);


int _f_toi(unsigned char *x)
{
    return(ftox(x,-1));
}

int f_toi(unsigned char *x)
{
    return(ftox(x,0));
}

int f_tou(unsigned char *x)
{
    return(ftox(x,1));
}

int ftox(unsigned char *x,int n)
{ unsigned char     fx[6];
  unsigned long     *ux,*ufx;
  unsigned long     a,b;
  int               r;

    a = 0;
    ux = (unsigned long *)x;
    ufx = (unsigned long *)fx;
    if (*ux == 0) return(a);
#if     FLTMPU
    if ((n > 0) && (x[0] & 0x80)) {
#else
    if ((n > 0) && (x[3] & 0x80)) {
#endif
        return(a);
    }

    *ufx = *ux;
#if     FLTMPU
    r = *(short *)x;
#else
    r = *(short *)(x+2);
#endif
    r >>= 7;
    r &= 0xff;
#if     FLTMPU
    fx[0] = 0;
    fx[1] |= 0x80;
    fx[5] = r;
    fx[4] = r >> 8;
#else
    fx[3] = 0;
    fx[2] |= 0x80;
    fx[4] = r;
    fx[5] = r >> 8;
#endif
    r = _regnormf(fx);
    *ufx += 1;
#if     FLTMPU
    if (n <= 0) fx[4] |= x[0] & 0x80;
#else
    if (n <= 0) fx[5] |= x[3] & 0x80;
#endif

    if (r >= -1) {
        if (r >= 0) {
            while (1) {
#if     FLTMPU
                b = fx[0];
#else
                b = fx[3];
#endif
                b >>= 4;
                a = a * 10 + b;
#if     FLTMPU
                fx[0] &= 0xf;
#else
                fx[3] &= 0xf;
#endif
                *ufx *= 10;
                if (r == 0) break;
                r--;
            }
            if (n >= 0) {
#if     FLTMPU
                b = fx[0];
#else
                b = fx[3];
#endif
                b >>= 4;
                if (b > 4) a += 1;
            }
        }
        else {
            if (n >= 0) {
#if     FLTMPU
                a = fx[0];
#else
                a = fx[3];
#endif
                a >>= 4;
                if (a >= 5) a = 1;
                else a = 0;
            }
            else a = 0;
        }
#if     FLTMPU
        if ((n <= 0) && (fx[4] & 0x80)) {
#else
        if ((n <= 0) && (fx[5] & 0x80)) {
#endif
            if (a > 0x80000000) a = 0x80000000;
            else a = 0 - a;
        }
        else {
            if ((n <= 0) && (a > 0x7fffffff)) a = 0x7fffffff;
        }
    }
    return(a);
}
