/*  Floating Point(Float) Calc Subroutines
        Copyright(c) 2007,  S.SAKAI     2007.3.5    */
#include    "fltmpu.h"

int     _fnorma(unsigned char *);

/*      x[3]..x[0] Normalize  x[5]x[4]++;   */
void _regm10f(unsigned char *x)
{ short *expx;
  int   f;
  unsigned long *ux;

    ux = (unsigned long *)x;
    expx = (short *)(x+4);

    *ux *= 5;
    (*expx)++;

    while(1) {
#if     FLTMPU
        if ((x[0] & 0xf0) == 0x10) break;
        f = x[3] & 0x1;
#else
        if ((x[3] & 0xf0) == 0x10) break;
        f = x[0] & 0x1;
#endif
        *ux >>= 1;
        (*expx)++;
    }
    if (f) (*ux)++;
}

/*      x[3]..x[0] Normalize  x[5]x[4]--;   */
void _regd10f(unsigned char *x)
{ short *expx;
  int   f;
  unsigned long *ux;

    ux = (unsigned long *)x;
    expx = (short *)(x+4);

    while(1) {
#if     FLTMPU
        if (x[0] & 0x80) break;
#else
        if (x[3] & 0x80) break;
#endif
        *ux <<= 1;
        (*expx)--;
    }
    *ux = (*ux + 5) / 10;
    f = 0;
    while(1) {
#if     FLTMPU
        if ((x[0] & 0xf0) == 0x10) break;
        if ((x[0] & 0xf0) > 0x10) {
            f = x[3] & 0x1;
#else
        if ((x[3] & 0xf0) == 0x10) break;
        if ((x[3] & 0xf0) > 0x10) {
            f = x[0] & 0x1;
#endif
            *ux >>= 1;
            (*expx)++;
        }
        else {
            f = 0;
            *ux <<= 1;
            (*expx)--;
        }
    }
    if (f) (*ux)++;
}

void _fnorm2(unsigned char *x,int es,short *ex)
{ unsigned short    *us;
  unsigned long     *ux;
  int       f;

    *ex += _fnorma(x);

    while (es) {
        if (es > 0) {
            _regm10f(x);
            es--;
        }
        else {
            _regd10f(x);
            es++;
        }
        if (es == 0) break;
    }

    ux = (unsigned long *)x;
    while(1) {
#if     FLTMPU
        f = x[3] & 0x1;
#else
        f = x[0] & 0x1;
#endif
        *ux >>= 1;
#if     FLTMPU
        if (x[0] == 0) break;
#else
        if (x[3] == 0) break;
#endif
    }
    if (f) {
        *ux += 1;
#if     FLTMPU
        if (x[0]) {
#else
        if (x[3]) {
#endif
            *ux = 0;
            *ex += 1;
        }
    }
}
