/*  Floating Point(Double) Calc Subroutine
        void itof(unsigned char *x,int);
        void utof(unsigned char *x,unsigned int);
        Copyright(c) 2007,  S.SAKAI     2007.3.6    */
#include    "fltmpu.h"

void    xtod(unsigned char *,int,int);
void    _regshld(unsigned char *);
void    _regshrd(unsigned char *);
void    _regdp1(unsigned char *);

void i_tod(unsigned char *x,int z)
{
    xtod(x,z,0);
}

void u_tod(unsigned char *x,unsigned int z)
{
    xtod(x,(int)z,1);
}

void xtod(unsigned char *x,int z,int n)
{ unsigned long     *ux;
  unsigned short    *us;
  int               f,expx,sgn;

    ux = (unsigned long *)x;

    if (z == 0) {
        *ux = 0;
        *(ux+1) = 0;
        return;
    }

    sgn = 0;
    if (n == 0) {
        if (z < 0) {
            sgn = 1;
            z = -z;
        }
    }

#if     FLTMPU
    *ux = z;
    *(ux+1) = 0;
#else
    *ux = 0;
    *(ux+1) = z;
#endif
    expx = 0x413;

#if     FLTMPU
    us = (unsigned short *)x;
#else
    us = (unsigned short *)(x+6);
#endif
    f = 0;
    while(1) {
        if ((*us & 0xfff0) == 0x10) break;
        if ((*us & 0xfff0) == 0) {
            f = 0;
            _regshld(x);
            expx -= 1;
        }
        else {
#if     FLTMPU
            f = x[7] & 0x1;
#else
            f = x[0] & 0x1;
#endif
            _regshrd(x);
            expx += 1;
        }
    }
    if (f) {
        _regdp1(x);
        if ((*us & 0xfff0) != 0x10) {
            _regshrd(x);
            expx += 1;
        }
    }
    *us &= 0xf;
    expx <<= 4;
#if     FLTMPU
    x[1] |= (expx & 0xf0);
    x[0] = expx >> 8;

    if ((n == 0) && (sgn != 0)) x[0] |= 0x80;
#else
    x[6] |= (expx & 0xf0);
    x[7] = expx >> 8;

    if ((n == 0) && (sgn != 0)) x[7] |= 0x80;
#endif
}
