/*  Floating Point(Float) Calc Subroutine
        void itof(unsigned char *x,int);
        void utof(unsigned char *x,unsigned int);
        Copyright(c) 2007,  S.SAKAI     2007.3.6    */
#include    "fltmpu.h"

void    xtof(unsigned char *,int,int);

void i_tof(unsigned char *x,int z)
{
    xtof(x,z,0);
}

void u_tof(unsigned char *x,unsigned int z)
{
    xtof(x,(int)z,1);
}

void xtof(unsigned char *x,int z,int n)
{ unsigned long     *ux;
  unsigned short    *us;
  int               f,expx,sgn;

    ux = (unsigned long *)x;

    if (z == 0) {
        *ux = 0;
        return;
    }

    sgn = 0;
    if (n == 0) {
        if (z < 0) {
            sgn = 1;
            z = -z;
        }
    }

    *ux = z;
    expx = 0x96;

#if     FLTMPU
    us = (unsigned short *)x;
#else
    us = (unsigned short *)(x+2);
#endif
    f = 0;
    while(1) {
        if ((*us & 0xff80) == 0x80) break;
        if ((*us & 0xff80) == 0) {
            f = 0;
            *ux <<= 1;
            expx -= 1;
        }
        else {
#if     FLTMPU
            f = x[3] & 0x1;
#else
            f = x[0] & 0x1;
#endif
            *ux >>= 1;
            expx += 1;
        }
    }

    if (f) {
        if (*ux == 0xffffff) {
            *ux = 0;
            expx += 1;
        }
        else *ux += 1;
    }

#if     FLTMPU
    x[1] &= 0x7f;
#else
    x[2] &= 0x7f;
#endif

    if (expx & 0x1) {
#if     FLTMPU
        x[1] |= 0x80;
#else
        x[2] |= 0x80;
#endif
    }
    expx >>= 1;
#if     FLTMPU
    x[0] = expx;
#else
    x[3] = expx;
#endif

    if ((n == 0) && (sgn != 0)) {
#if     FLTMPU
        x[0] |= 0x80;
#else
        x[3] |= 0x80;
#endif
    }
}
