--  Floating Point(double) Calucuration Program Subroutines
--      Copyright(c) 2007, S.SAKAI  2007.4.10


--      void _ovrfld(char *x,int s)
--          s = 0(x >= 0)   x[7]..x[0] = 0xff....ff;
--          s != 0(x < 0)   x[7]..x[0] = 0x7f....ff;
        .text
        .globl  __ovrfld
        .align  4
__ovrfld:
        mov     0xffffffff,r10
        st.w    r10,[r6]
        and     r7,r7
        bnz     ovrfld1
        mov     0x7fffffff,r10
ovrfld1:st.w    r10,4[r6]
        jmp     [lp]

--      void _undfld(char *x)
--          x[7]..x[0] = 0x00..00;
        .text
        .globl  __undfld
        .align  4
__undfld:
        st.w    r0,[r6]
        st.w    r0,4[r6]
        jmp     [lp]


--      void _regdp1(unsigned char *x)
--          x[7]..x[0] += 1;
        .text
        .globl  __regdp1
        .align  4
__regdp1:
        ld.w    [r6],r10;
        add     0x1,r10
        st.w    r10,[r6]
        bnc     gegdp11
        ld.w    4[r6],r10;
        add     0x1,r10
        st.w    r10,4[r6]
gegdp11:jmp     [lp]

--      void _regshld(char *x)
--          x[7]..x[0] <<= 1;
        .text
        .globl  __regshld
        .align  4
__regshld:
        ld.w    4[r6],r10;
        shl     1,r10
        ld.w    [r6],r9;
        shl     1,r9
        st.w    r9,[r6]
        bnc     regshld1
        ori     0x1,r10,r10
regshld1:
        st.w    r10,4[r6]
        jmp     [lp]

--      void _regshrd(char *x)
--          x[7]..x[0] >>= 1;
        .text
        .globl  __regshrd
        .align  4
__regshrd:
        ld.w    [r6],r10;
        shr     1,r10
        ld.w    4[r6],r9;
        shr     1,r9
        st.w    r9,4[r6]
        bnc     regshrd1
        mov     0x80000000,r9
        or      r9,r10
regshrd1:
        st.w    r10,[r6]
        jmp     [lp]

--      void _mlt10d(char *x)
--          x[7]..x[0] *= 10;
        .text
        .globl  __mlt10d
        .align  4
__mlt10d:
        ld.w    [r6],r10
        mulu    10,r10,r7
        st.w    r10,[r6]
        ld.w    4[r6],r10
        mulu    10,r10,r8
        add     r7,r10
        st.w    r10,4[r6]
        jmp     [lp]

--      void _div10d(char *x)
--          x[7]..x[0] /= 10;
        .text
        .globl  __div10d
        .align  4
__div10d:
        ld.w    4[r6],r10
        mov     10,r9
        divu    r9,r10,r7
        st.w    r10,4[r6]
        ld.w    2[r6],r10
        andi    0xffff,r10,r10
        shl     16,r7
        or      r7,r10
        divu    r9,r10,r7
        st.h    r10,2[r6]
        ld.w    [r6],r10
        andi    0xffff,r10,r10
        shl     16,r7
        or      r7,r10
        divu    r9,r10,r7
        st.h    r10,[r6]
        cmp     5,r7
        bc      div10d1
        ld.w    [r6],r10
        add     1,r10
        st.w    r10,[r6]
        bnc     div10d1
        ld.w    4[r6],r10
        add     1,r10
        st.w    r10,4[r6]
div10d1:
        jmp     [lp]

--      int _zrchkd(char *x)
--          x[7]..x[0] == 0     r = 1
--                     != 0     r = 0
        .text
        .globl  __zrchkd
        .align  4
__zrchkd:
        ld.w    [r6],r10
        and     r10,r10
        bnz     zrchkd1
        ld.w    4[r6],r10
        and     r10,r10
        bnz     zrchkd1
        mov     1,r10
        jmp     [lp]
zrchkd1:
        xor     r10,r10
        jmp     [lp]


--      void _dneg(char *x)
--          x[7]..x[0] == 0 - x[7]..x[0]
        .text
        .globl  __dneg
        .align  4
__dneg:
        ld.w    [r6],r7
        ld.w    4[r6],r8
        not     r7,r7
        not     r8,r8
        add     1,r7
        bnc     dneg1
        add     1,r8
dneg1:
        st.w    r8,4[r6]
        st.w    r7,[r6]
        jmp     [lp]


--  int _dnorm(char *x)
--      r:x[7]x[6] >> 4
--      (x[7]x[6] & 0xf) | 0x10;    x[7]..x[0] <<= 8;
        .text
        .globl  __dnorm
        .align  4
__dnorm:
        ld.h    6[r6],r10
        shr     4,r10
        andi    0xfff,r10,r10

        ld.w    4[r6],r8
        mov     0xfffff,r7
        and     r7,r8
        mov     0x100000,r7
        or      r7,r8
        shl     8,r8
        ld.w    [r6],r7
        shr     24,r7
        or      r7,r8
        ld.w    [r6],r7
        shl     8,r7
        st.w    r7,[r6]
        st.w    r8,4[r6]
        jmp     [lp]

--      void _danorm(char *x,int a)
--          x[7]..x[0] >>= 8;
--          (x[7]x[6] & 0xf) |= (a << 4)
        .text
        .globl  __danorm
        .align  4
__danorm:
        xor     r8,r8
        ld.w    [r6],r10
        shr     8,r10
        bnc     danorm1
        add     1,r8
danorm1:
        ld.w    4[r6],r9
        shl     24,r9
        or      r9,r10
        ld.w    4[r6],r9
        shr     8,r9
        add     r8,r10
        bnc     danorm2
        add     1,r9
        mov     0xffe00000,r8
        and     r9,r8
        bz      danorm2
        add     -1,r10
        add     -1,r9
danorm2:
        mov     0xfffff,r8
        and     r8,r9
        shl     20,r7
        or      r7,r9
        st.w    r10,[r6]
        st.w    r9,4[r6]
        jmp     [lp]


--      void _dnormshr(char *x,int n)
--          x[7]..x[0] >>= n;
        .text
        .globl  __dnormshr
        .align  4
__dnormshr:
        and     r7,r7
        bz      dnormshr0
        xor     r10,r10
        mov     64,r8
        cmp     r8,r7
        bc      dnormshr2
        bnz     dnormshr1
        ld.b    7[r6],r10
        andi    0x80,r10,r10
        bz      dnormshr1
        mov     1,r10
dnormshr1:
        st.w    r10,[r6]
        st.w    r0,4[r6]
dnormshr0:
        jmp     [lp]

dnormshr2:
        mov     31,r8
        cmp     r8,r7
        bnh     dnormshr5
        ld.w    4[r6],r10
        addi    -32,r7,r7
        bnz     dnormshr3
        ld.b    3[r6],r8
        andi    0x80,r8,r8
        bz      dnormshr4
        addi    1,r10,r10
        bnc     dnormshr4
        mov     1,r8
        st.w    r8,4[r6]
        st.w    r10,[r6]
        jmp     [lp]

dnormshr3:
        shr     r7,r10
        bnc     dnormshr4
        addi    1,r10,r10
        bnc     dnormshr4
        st.w    r10,[r6]
        mov     1,r10
        st.w    r10,4[r6]
        jmp     [lp]
dnormshr4:
        st.w    r0,4[r6]
        st.w    r10,[r6]
        jmp     [lp]

dnormshr5:
        ld.w    4[r6],r10
        mov     r10,r9
        shr     r7,r10
        st.w    r10,4[r6]
        ld.w    [r6],r10
        shr     r7,r10
        mov     1,r8
        bc      dnormshr6
        mov     0,r8
dnormshr6:
        not     r7,r7
        addi    33,r7,r7
        shl     r7,r9
        or      r9,r10
        and     r8,r8
        bz      dnormshr7
        addi    1,r10,r10
        bnc     dnormshr7
        st.w    r10,[r6]
        ld.w    4[r6],r10
        addi    1,r10,r10
        st.w    r10,4[r6]
        jmp     [lp]
dnormshr7:
        st.w    r10,[r6]
        jmp     [lp]


--      void _dnormshl(char *x,int n)
--          x[7]..x[0] <<= n;
        .text
        .globl  __dnormshl
        .align  4
__dnormshl:
        and     r7,r7
        bz      dnormshl0
        mov     64,r9
        cmp     r9,r7
        bc      dnormshl1
        st.w    r0,4[r6]
        st.w    r0,[r6]
dnormshl0:
        jmp     [lp]

dnormshl1:
        mov     31,r9
        cmp     r9,r7
        bnh     dnormshl3
        ld.w    [r6],r10
        addi    -32,r7,r7
        bz      dnormshl2
        shl     r7,r10
dnormshl2:
        st.w    r10,4[r6]
        st.w    r0,[r6]
        jmp     [lp]

dnormshl3:
        ld.w    [r6],r10
        mov     r10,r9
        shl     r7,r10
        st.w    r10,[r6]
        ld.w    4[r6],r10
        shl     r7,r10
        not     r7,r7
        addi    33,r7,r7
        shr     r7,r9
        or      r9,r10
        st.w    r10,4[r6]
        jmp     [lp]

--      int _dcmpxy(unsigned char *x,unsigned char *y)
--          x[7]..x[0] < y[7]..y[0]     r=-1;
--          x[7]..x[0] == y[7]..y[0]    r=0;
--          x[7]..x[0] > y[7]..y[0]     r=1;
        .text
        .globl  __dcmpxy
        .align  4
__dcmpxy:
        ld.w    4[r6],r8
        ld.w    4[r7],r9
        cmp     r9,r8
        bh      dcmpxy1
        bc      dcmpxy2
        ld.w    [r6],r8
        ld.w    [r7],r9
        cmp     r9,r8
        bh      dcmpxy1
        bc      dcmpxy2
        mov     r0,r10
        jmp     [lp]
dcmpxy1:mov     1,r10
        jmp     [lp]
dcmpxy2:mov     -1,r10
        jmp     [lp]

