/*      Test Program for Floating Point Calculation Library
            Copyright(c) 2007,  S.SAKAI     2007.7.5
*/
//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "float.h"
#include <math>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

HANDLE  RsOpen(int,int);

int     comout(char *);
int     comin(char *);
void    IniFileRead(void);
void    IniFileWr(void);
void    xRdisp(char *);
void    yRdisp(char *);
int     fmtcalf(float);
int     fmtcald(double);

HANDLE  hCom;
int     RsPort,RsBauRate;
int     Cpu_x,fd_Select;
int     fRsErr,fRsInit=0;
int     f_Disp,n_Dispf,n_Dispd;

double  xRegd,yRegd;
float   xRegf,yRegf;
unsigned char   xReg1[8],yReg1[8],xReg2[8],yReg2[8];


TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{ char  c[64];

    RsPort = (RadioGroup2->ItemIndex) + 1;
    Cpu_x = RadioGroup1->ItemIndex;
    fd_Select = RadioGroup3->ItemIndex;
    n_Dispf = StrToInt(Edit3->Text);
    n_Dispd = StrToInt(Edit4->Text);
    f_Disp = RadioGroup4->ItemIndex;

    IniFileRead();

    RadioGroup2->ItemIndex = RsPort - 1;
    RadioGroup1->ItemIndex = Cpu_x;
    RadioGroup3->ItemIndex = fd_Select;;
    Edit3->Text = IntToStr(n_Dispf);
    Edit4->Text = IntToStr(n_Dispd);
    RadioGroup4->ItemIndex = f_Disp;

    if (Cpu_x == 0) RsBauRate = 115200;
    else RsBauRate = 57600;

    if (Cpu_x <= 1) {
        CloseHandle(hCom);
        Sleep(50);
        hCom = RsOpen(RsPort,RsBauRate);
        if (hCom == INVALID_HANDLE_VALUE) {
            fRsErr = 1;
            if (MessageBox(NULL,"ʐM|[gG[ H","ZeXg",MB_OK)==1);
        }
        else fRsErr = 0;
    }
    fRsInit = 1;

    Top = (GetSystemMetrics(SM_CYSCREEN) - Height)/2;
    Left = (GetSystemMetrics(SM_CXSCREEN) - Width)/2;

    StringGrid1->ColWidths[0] = 64;
    StringGrid1->ColWidths[1] = 204;
    StringGrid1->ColWidths[2] = 192;
    StringGrid1->ColWidths[3] = 2;
    StringGrid1->ColWidths[4] = 204;
    StringGrid1->ColWidths[5] = 192;

    StringGrid1->Cells[0][1] = "  PC";
    StringGrid1->Cells[0][2] = " PC Sim";
    if (Cpu_x == 0)StringGrid1->Cells[0][3] = "  V850";
    if (Cpu_x == 1)StringGrid1->Cells[0][3] = "  SH-2";

    StringGrid1->Cells[1][0] = "      x Reg";
    StringGrid1->Cells[2][0] = "      x (HEX)";
    StringGrid1->Cells[4][0] = "      y Reg";
    StringGrid1->Cells[5][0] = "      y (HEX)";

    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        if (fd_Select == 0) c[0] = 'F';
        else c[0] = 'D';
        c[1] = 0;
        fRsErr = comout(c);
    }
    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        if (f_Disp == 0) c[0] = 'K';
        else c[0] = 'k';
        c[1] = 0;
        fRsErr = comout(c);
    }
    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        n_Dispf = StrToInt(Form1->Edit3->Text);
        wsprintf(c,"j%d\015",n_Dispf);
        fRsErr = comout(c);
    }
    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        n_Dispd = StrToInt(Form1->Edit4->Text);
        wsprintf(c,"J%d\015",n_Dispd);
        fRsErr = comout(c);
    }

    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        c[0] = 'x';
        c[1] = 0;
        fRsErr = comout(c);
        if (fRsErr == 0) {
            fRsErr = comin(c);
        }
    }
    xRdisp(c);

    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        c[0] = 'y';
        c[1] = 0;
        fRsErr = comout(c);
        if (fRsErr == 0) {
            fRsErr = comin(c);
        }
    }
    yRdisp(c);

    if (fRsErr) {
        if (MessageBox(NULL,"ʐMG[ H","ZeXg",MB_OK)==1);
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button33Click(TObject *Sender)      // End
{
    CloseHandle(hCom);
    IniFileWr();
    Close();
}
//---------------------------------------------------------------------------

void xRdisp(char *c)
{ char          cc[32],fmt[16];
  int           i,j,k;
  unsigned char *p;
  TVarRec       args[4];
  AnsiString    As;

    if (fd_Select == 0) {
        args[0] = xRegf;
        i = StrToInt(n_Dispf);
        if (f_Disp == 0) {
            if (xRegf== 0) {
                wsprintf(fmt," %%%d.%dE",i+2,i);
                As = Format(fmt,args,0);
            }
            else if (xRegf > 0) {
                wsprintf(fmt,"+%%%d.%dE",i+2,i);
                As = Format(fmt,args,0);
            }
            else if (xRegf < 0) {
                wsprintf(fmt,"%%%d.%dE",i+2,i);
                As = Format(fmt,args,0);
            }
        }
        else {
            k = fmtcalf(xRegf);
            if (k > i) k = i;
            if (xRegf == 0) {
                wsprintf(fmt," %%%d.%df",i,i-k);
                As = Format(fmt,args,0);
            }
            else if (xRegf > 0) {
                wsprintf(fmt,"+%%%d.%df",i,i-k);
                As = Format(fmt,args,0);
            }
            else if (xRegf < 0) {
                wsprintf(fmt,"%%%d.%df",i,i-k);
                As = Format(fmt,args,0);
            }
        }
        Form1->StringGrid1->Cells[1][1] = As;
        p = (unsigned char *)&xRegf;
        wsprintf(cc,"%02X %02X %02X %02X",p[0],p[1],p[2],p[3]);
        Form1->StringGrid1->Cells[2][1] = cc;

        j = 0;
        for(i=0;i<4;i++) if (xReg1[i] != 0) j++;
        if (Form1->RadioGroup4->ItemIndex == 0) k = -n_Dispf;
        else k = n_Dispf;
        if (j == 0) {
            cc[0] = ' ';
            f_toa(cc+1,xReg1,k);
        }
        else f_toa(cc,xReg1,k);
        Form1->StringGrid1->Cells[1][2] = cc;
        wsprintf(cc,"%02X %02X %02X %02X",xReg1[0],xReg1[1],xReg1[2],xReg1[3]);
        Form1->StringGrid1->Cells[2][2] = cc;
    }
    else {
        args[0] = xRegd;
        i = StrToInt(n_Dispd);
        if (f_Disp == 0) {
            if (xRegd == 0) {
                wsprintf(fmt," %%%d.%dE",i+2,i);
                As = Format(fmt,args,0);
            }
            else if (xRegd > 0) {
                wsprintf(fmt,"+%%%d.%dE",i+2,i);
                As = Format(fmt,args,0);
            }
            else if (xRegd < 0) {
                wsprintf(fmt,"%%%d.%dE",i+2,i);
                As = Format(fmt,args,0);
            }
        }
        else {
            k = fmtcald(xRegd);
            if (k > i) k = i;
            if (xRegd == 0) {
                wsprintf(fmt," %%%d.%df",i,i-k);
                As = Format(fmt,args,0);
            }
            else if (xRegd > 0) {
                wsprintf(fmt,"+%%%d.%df",i,i-k);
                As = Format(fmt,args,0);
            }
            else if (xRegd < 0) {
                wsprintf(fmt,"%%%d.%df",i,i-k);
                As = Format(fmt,args,0);
            }
        }
        Form1->StringGrid1->Cells[1][1] = As;
        p = (unsigned char *)&xRegd;
        wsprintf(cc,"%02X %02X %02X %02X %02X %02X %02X %02X",
            p[0],p[1],p[2],p[3],p[4],p[5],p[6],p[7]);
        Form1->StringGrid1->Cells[2][1] = cc;

        j = 0;
        for(i=0;i<8;i++) if (xReg1[i] != 0) j++;
        if (Form1->RadioGroup4->ItemIndex == 0) k = -n_Dispd;
        else k = n_Dispd;
        if (j == 0) {
            cc[0] = ' ';
            d_toa(cc+1,xReg1,k);
        }
        else d_toa(cc,xReg1,k);
        Form1->StringGrid1->Cells[1][2] = cc;
        wsprintf(cc,"%02X %02X %02X %02X %02X %02X %02X %02X",
            xReg1[0],xReg1[1],xReg1[2],xReg1[3],xReg1[4],xReg1[5],xReg1[6],xReg1[7]);
        Form1->StringGrid1->Cells[2][2] = cc;
    }

    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        i = 0;
        j = 0;
        while(1) {
            if (c[i++] == ' ') j++;
            if ((fd_Select == 0) && (j >= 4)) break;
            if ((fd_Select == 1) && (j >= 8)) break;
        }
        c[i-1] = 0;
        while(1) {
            if (c[i] != ' ') break;
            i++;
        }
        if (!((c[i] == '+') || (c[i] == '-'))) i--;;
        Form1->StringGrid1->Cells[2][3] = c;
        Form1->StringGrid1->Cells[1][3] = c + i;
    }
    Form1->Edit2->Text = "";
}

void yRdisp(char *c)
{ char          cc[32],fmt[16];
  int           i,j,k;
  unsigned char *p;
  double        a;
  TVarRec       args[4];
  AnsiString    As;

    if (fd_Select == 0) {
        args[0] = yRegf;
        i = StrToInt(n_Dispf);
        if (f_Disp == 0) {
            if (yRegf == 0) {
                wsprintf(fmt," %%%d.%dE",i+2,i);
                As = Format(fmt,args,0);
            }
            else if (yRegf > 0) {
                wsprintf(fmt,"+%%%d.%dE",i+2,i);
                As = Format(fmt,args,0);
            }
            else if (yRegf < 0) {
                wsprintf(fmt,"%%%d.%dE",i+3,i+1);
                As = Format(fmt,args,0);
            }
        }
        else {
            k = fmtcalf(yRegf);
            if (k > i) k = i;
            if (yRegf == 0) {
                wsprintf(fmt," %%%d.%df",i,i-k);
                As = Format(fmt,args,0);
            }
            else if (yRegf > 0) {
                wsprintf(fmt,"+%%%d.%df",i,i-k);
                As = Format(fmt,args,0);
            }
            else if (yRegf < 0) {
                wsprintf(fmt,"%%%d.%df",i,i-k);
                As = Format(fmt,args,0);
            }
        }
        Form1->StringGrid1->Cells[4][1] = As;
        p = (unsigned char *)&yRegf;
        wsprintf(cc,"%02X %02X %02X %02X",p[0],p[1],p[2],p[3]);
        Form1->StringGrid1->Cells[5][1] = cc;

        j = 0;
        for(i=0;i<4;i++) if (yReg1[i] != 0) j++;
        if (Form1->RadioGroup4->ItemIndex == 0) k = -n_Dispf;
        else k = n_Dispf;
        if (j == 0) {
            cc[0] = ' ';
            f_toa(cc+1,yReg1,k);
        }
        else f_toa(cc,yReg1,k);
        Form1->StringGrid1->Cells[4][2] = cc;
        wsprintf(cc,"%02X %02X %02X %02X",yReg1[0],yReg1[1],yReg1[2],yReg1[3]);
        Form1->StringGrid1->Cells[5][2] = cc;
    }
    else {
        args[0] = yRegd;
        i = StrToInt(n_Dispd);
        if (f_Disp == 0) {
            if (yRegd == 0) {
                wsprintf(fmt," %%%d.%dE",i+2,i);
                As = Format(fmt,args,0);
            }
            else if (yRegd > 0) {
                wsprintf(fmt,"+%%%d.%dE",i+2,i);
                As = Format(fmt,args,0);
            }
            else if (yRegd < 0) {
                wsprintf(fmt,"%%%d.%dE",i+3,i+1);
                As = Format(fmt,args,0);
            }
        }
        else {
            k = fmtcald(yRegd);
            if (k > i) k = i;
            if (yRegd == 0) {
                wsprintf(fmt," %%%d.%df",i,i-k);
                As = Format(fmt,args,0);
            }
            else if (yRegd > 0) {
                wsprintf(fmt,"+%%%d.%df",i,i-k);
                As = Format(fmt,args,0);
            }
            else if (yRegd < 0) {
                wsprintf(fmt,"%%%d.%df",i,i-k);
                As = Format(fmt,args,0);
            }
        }
        Form1->StringGrid1->Cells[4][1] = As;
        p = (unsigned char *)&yRegd;
        wsprintf(cc,"%02X %02X %02X %02X %02X %02X %02X %02X",
            p[0],p[1],p[2],p[3],p[4],p[5],p[6],p[7]);
        Form1->StringGrid1->Cells[5][1] = cc;

        j = 0;
        for(i=0;i<8;i++) if (yReg1[i] != 0) j++;
        if (Form1->RadioGroup4->ItemIndex == 0) k = -n_Dispd;
        else k = n_Dispd;
        if (j == 0) {
            cc[0] = ' ';
            d_toa(cc+1,yReg1,k);
        }
        else d_toa(cc,yReg1,k);
        Form1->StringGrid1->Cells[4][2] = cc;
        wsprintf(cc,"%02X %02X %02X %02X %02X %02X %02X %02X",
            yReg1[0],yReg1[1],yReg1[2],yReg1[3],yReg1[4],yReg1[5],yReg1[6],yReg1[7]);
        Form1->StringGrid1->Cells[5][2] = cc;
    }

    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        i = 0;
        j = 0;
        while(1) {
            if (c[i++] == ' ') j++;
            if ((fd_Select == 0) && (j >= 4)) break;
            if ((fd_Select == 1) && (j >= 8)) break;
        }
        c[i-1] = 0;
        while(1) {
            if (c[i] != ' ') break;
            i++;
        }
        if (!((c[i] == '+') || (c[i] == '-'))) i--;;
        Form1->StringGrid1->Cells[5][3] = c;
        Form1->StringGrid1->Cells[4][3] = c + i;
    }
    Form1->Edit2->Text = "";
}

void yRdispx(int n,int m,char *c)
{ char          cc[32];
  int           i,j;
  unsigned char *p;
  TVarRec       args[4];
  AnsiString    As;


    if (n >=0) wsprintf(cc,"+%d",n);
    else wsprintf(cc,"%d",n);
    Form1->StringGrid1->Cells[4][1] = cc;
    p = (unsigned char *)&n;
    wsprintf(cc,"%02X %02X %02X %02X",p[0],p[1],p[2],p[3]);
    Form1->StringGrid1->Cells[5][1] = cc;

    if (m >=0) wsprintf(cc,"+%d",m);
    else wsprintf(cc,"%d",m);
    Form1->StringGrid1->Cells[4][2] = cc;
    p = (unsigned char *)&m;
    wsprintf(cc,"%02X %02X %02X %02X",p[0],p[1],p[2],p[3]);
    Form1->StringGrid1->Cells[5][2] = cc;

    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        i = 0;
        j = 0;
        while(1) {
            if (c[i++] == ' ') j++;
            if (j >= 4) break;
        }
        c[i-1] = 0;
        while(1) {
            if (c[i] != ' ') break;
            i++;
        }
        if (!((c[i] == '+') || (c[i] == '-'))) i--;;
        Form1->StringGrid1->Cells[5][3] = c;
        Form1->StringGrid1->Cells[4][3] = c + i;
    }
}

void yRdispy(unsigned int n,unsigned int m,char *c)
{ char          cc[32];
  int           i,j;
  unsigned char *p;
  TVarRec       args[4];
  AnsiString    As;


    if (n == 0) wsprintf(cc," %u",n);
    else wsprintf(cc,"+%u",n);
    Form1->StringGrid1->Cells[4][1] = cc;
    p = (unsigned char *)&n;
    wsprintf(cc,"%02X %02X %02X %02X",p[0],p[1],p[2],p[3]);
    Form1->StringGrid1->Cells[5][1] = cc;

    if (m == 0) wsprintf(cc," %u",m);
    else wsprintf(cc,"+%u",m);
    Form1->StringGrid1->Cells[4][2] = cc;
    p = (unsigned char *)&m;
    wsprintf(cc,"%02X %02X %02X %02X",p[0],p[1],p[2],p[3]);
    Form1->StringGrid1->Cells[5][2] = cc;

    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        i = 0;
        j = 0;
        while(1) {
            if (c[i++] == ' ') j++;
            if (j >= 4) break;
        }
        c[i-1] = 0;
        while(1) {
            if (c[i] != ' ') break;
            i++;
        }
        if (!((c[i] == '+') || (c[i] == '-'))) i--;;
        Form1->StringGrid1->Cells[5][3] = c;
        Form1->StringGrid1->Cells[4][3] = c + i;
    }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::RadioGroup1Click(TObject *Sender)
{ int   i;
  char  c[4];

    if (fRsInit) {
        Cpu_x = RadioGroup1->ItemIndex;
        if (Cpu_x <= 1) {
            CloseHandle(hCom);
            Sleep(50);
            if (Cpu_x == 0) RsBauRate = 115200;
            else RsBauRate = 57600;
            hCom = RsOpen(RsPort,RsBauRate);
            if (hCom == INVALID_HANDLE_VALUE) {
                fRsErr = 1;
                if (Cpu_x == 0) {
                    MessageBox(NULL,"|[gG[","PC  V850 {[h",MB_OK);
                }
                else {
                    MessageBox(NULL,"|[gG[","PC  SH-2 {[h",MB_OK);
                }
            }
            else fRsErr = 0;
        }
        if (Cpu_x == 0) StringGrid1->Cells[0][3] = "  V850";
        if (Cpu_x == 1) StringGrid1->Cells[0][3] = "  SH-2";
        if (Cpu_x == 2) for(i=0;i<6;i++) StringGrid1->Cells[i][3] = "";

        if ((Cpu_x <= 1) && (fRsErr == 0)) {
            if (fd_Select == 0) c[0] = 'F';
            else c[0] = 'D';
            c[1] = 0;
            fRsErr = comout(c);
        }
        if ((Cpu_x <= 1) && (fRsErr == 0)) {
            if (f_Disp == 0) c[0] = 'K';
            else c[0] = 'k';
            c[1] = 0;
            fRsErr = comout(c);
        }
        if ((Cpu_x <= 1) && (fRsErr == 0)) {
            n_Dispf = StrToInt(Form1->Edit3->Text);
            wsprintf(c,"j%d\015",n_Dispf);
            fRsErr = comout(c);
        }
        if ((Cpu_x <= 1) && (fRsErr == 0)) {
            n_Dispd = StrToInt(Form1->Edit4->Text);
            wsprintf(c,"J%d\015",n_Dispd);
            fRsErr = comout(c);
        }
    }
}

//---------------------------------------------------------------------------
void __fastcall TForm1::RadioGroup2Click(TObject *Sender)
{
    if (fRsInit) {
        RsPort = (RadioGroup2->ItemIndex) + 1;

        CloseHandle(hCom);
        Sleep(50);
        if (Cpu_x == 0) RsBauRate = 115200;
        else RsBauRate = 57600;
        hCom = RsOpen(RsPort,RsBauRate);
        if (hCom == INVALID_HANDLE_VALUE) {
            fRsErr = 1;
            if (Cpu_x == 0) {
                MessageBox(NULL,"|[gG[","PC  V850 {[h",MB_OK);
            }
            else {
                MessageBox(NULL,"|[gG[","PC  SH-2 {[h",MB_OK);
            }
        }
        else fRsErr = 0;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioGroup3Click(TObject *Sender)
{ char  cc[4];
  DWORD n;

    if (fRsInit) {
        fd_Select = RadioGroup3->ItemIndex;
        if ((Cpu_x <= 1) && (fRsErr == 0)) {
            if (fd_Select == 0) cc[0] = 'F';
            else cc[0] = 'D';
            WriteFile(hCom,cc,1,&n,NULL);
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::RadioGroup4Click(TObject *Sender)
{ char  cc[4];
  DWORD n;

    if (fRsInit) {
        f_Disp = RadioGroup4->ItemIndex;
        if ((Cpu_x <= 1) && (fRsErr == 0)) {
            if (f_Disp == 0) cc[0] = 'K';
            else cc[0] = 'k';
            WriteFile(hCom,cc,1,&n,NULL);
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit3Change(TObject *Sender)
{ char  cc[8];
  DWORD n;

    if (fRsInit) {
        n_Dispf = StrToInt(Edit3->Text);
        if (n_Dispf < 1) {
            n_Dispf = 1;
            Edit3->Text = IntToStr(n_Dispf);
        }
        if (n_Dispf > 10) {
            n_Dispf = 10;
            Edit3->Text = IntToStr(n_Dispf);
        }
        if ((Cpu_x <= 1) && (fRsErr == 0)) {
            wsprintf(cc,"j%d\015",n_Dispf);
            WriteFile(hCom,cc,lstrlen(cc),&n,NULL);
        }
    }
}

//---------------------------------------------------------------------------

void __fastcall TForm1::Edit4Change(TObject *Sender)
{ char  cc[8];
  DWORD n;

    if (fRsInit) {
        n_Dispd = StrToInt(Edit4->Text);
        if (n_Dispd < 1) {
            n_Dispd = 1;
            Edit4->Text = IntToStr(n_Dispd);
        }
        if (n_Dispd > 18) {
            n_Dispd = 18;
            Edit4->Text = IntToStr(n_Dispd);
        }
        if ((Cpu_x <= 1) && (fRsErr == 0)) {
            wsprintf(cc,"J%d\015",n_Dispd);
            WriteFile(hCom,cc,lstrlen(cc),&n,NULL);
        }
    }
}
//---------------------------------------------------------------------------

void readrs(char x,char *c)
{ int   i;
  char  cc[4];
  DWORD n;

    Sleep(15);
    cc[0] = x;
    WriteFile(hCom,cc,1,&n,NULL);
    i = 0;
    while(1) {
        while(1) {
            ReadFile(hCom,cc,1,&n,NULL);
            if (n) break;
        }
        if (cc[0] == 0xd) break;
        c[i++] = cc[0];
    }
    c[i] = 0;
}


void __fastcall TForm1::Button31Click(TObject *Sender)      // x Set
{ char  c[64];
  int   i;
  char  *cp = new char[ Edit1->Text.Length() + 1 ];
  DWORD n;

    if (fd_Select == 0) {
        xRegf = StrToFloat(Edit1->Text);
        a_tof((Edit1->Text).c_str(),xReg1);
    }
    else {
        xRegd = StrToFloat(Edit1->Text);
        a_tod((Edit1->Text).c_str(),xReg1);
    }

    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        strcpy( cp, Edit1->Text.c_str());
        c[0] = 'X';
        i = 1;
        while(1) {
            c[i] = *cp++;
            if (c[i] == 0) break;
            i++;
        }
        c[i++] = 0xd;
        c[i] = 0;

        WriteFile(hCom,c,lstrlen(c),&n,NULL);
        readrs('x',c);
    }
    xRdisp(c);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button32Click(TObject *Sender)      // y Set
{ char  c[64];
  int   i;
  char  *cp = new char[ Edit1->Text.Length() + 1 ];
  DWORD n;

    if (fd_Select == 0) {
        yRegf = StrToFloat(Edit1->Text);
        a_tof((Edit1->Text).c_str(),yReg1);
    }
    else {
        yRegd = StrToFloat(Edit1->Text);
        a_tod((Edit1->Text).c_str(),yReg1);
    }

    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        strcpy( cp, Edit1->Text.c_str());

        c[0] = 'Y';
        i = 1;
        while(1) {
            c[i] = *cp++;
            if (c[i] == 0) break;
            i++;
        }
        c[i++] = 0xd;
        c[i] = 0;

        WriteFile(hCom,c,lstrlen(c),&n,NULL);
        readrs('y',c);
    }
    yRdisp(c);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button1Click(TObject *Sender)       // deg -> rad
{ char          c[64];
  double        *paid;
  float         *paif;
  unsigned char fx[8];

    if (fd_Select == 0) {
        f_pai(fx,5);
        paif = (float *)fx;
        xRegf /= *paif;
        f_rad(xReg1);
    }
    else {
        d_pai(fx,5);
        paid = (double *)fx;
        xRegd /= *paid;
        d_rad(xReg1);
    }
    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        readrs('r',c);
    }
    xRdisp(c);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)       // rad -> deg
{ char          c[64];
  double        *paid;
  float         *paif;
  unsigned char fx[8];

    if (fd_Select == 0) {
        f_pai(fx,5);
        paif = (float *)fx;
        xRegf *= *paif;
        f_deg(xReg1);
    }
    else {
        d_pai(fx,5);
        paid = (double *)fx;
        xRegd *= *paid;
        d_deg(xReg1);
    }
    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        readrs('d',c);
    }
    xRdisp(c);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)       // neg
{ char          c[64];

    if (fd_Select == 0) {
        xRegf = -xRegf;
        f_neg(xReg1);
    }
    else {
        xRegd = -xRegd;
        d_neg(xReg1);
    }
    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        readrs('n',c);
    }
    xRdisp(c);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)       // x <-> y
{ char          c[64],c2[64];
  float         f;
  double        d;
  DWORD         n;

    if (fd_Select == 0) {
        f = xRegf;
        xRegf = yRegf;
        yRegf = f;
        f_xchg(xReg1,yReg1);
    }
    else {
        d = xRegd;
        xRegd = yRegd;
        yRegd = d;
        d_xchg(xReg1,yReg1);
    }
    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        c[0] = 'e';
        WriteFile(hCom,c,1,&n,NULL);
        readrs('x',c);
        readrs('y',c2);
    }
    xRdisp(c);
    yRdisp(c2);

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button34Click(TObject *Sender)      // Double -> Float
{ char  c[64];

    if (fd_Select == 1) {
        yRegf = xRegd;
        d_tof(yReg1,xReg1);

        if ((Cpu_x <= 1) && (fRsErr == 0)) {
            readrs('B',c);
        }
        fd_Select = 0;
        yRdisp(c);
        fd_Select = 1;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button35Click(TObject *Sender)      // Float -> Double
{ char  c[64];

    if (fd_Select == 0) {
        yRegd = xRegf;
        f_tod(yReg1,xReg1);

        if ((Cpu_x <= 1) && (fRsErr == 0)) {
            readrs('A',c);
        }
        fd_Select = 1;
        yRdisp(c);
        fd_Select = 0;
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button40Click(TObject *Sender)      // UInt -> Float
{ int   i;
  unsigned long n;
  char  c[64];
  char  *cp = new char[ Edit1->Text.Length() + 1 ];
  DWORD nn;

    n = StrToInt64(Edit1->Text);
    yRegf = n;
    u_tof(yReg1,n);
    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        strcpy(cp,Edit1->Text.c_str());
        i = 0;
        c[i++] = 'Z';
        while(1) {
            if (*cp == 0) break;
            c[i++] = *cp++;
        }
        c[i++] = 0xd;
        c[i] = 0;
        WriteFile(hCom,c,lstrlen(c),&nn,NULL);
        readrs('G',c);
    }
    n = fd_Select;
    fd_Select = 0;
    yRdisp(c);
    fd_Select = n;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button36Click(TObject *Sender)      // Int -> Float
{ int   i,n;
  char  c[64];
  char  *cp = new char[ Edit1->Text.Length() + 1 ];
  DWORD nn;

    n = StrToInt(Edit1->Text);
    yRegf = n;
    i_tof(yReg1,n);
    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        strcpy(cp,Edit1->Text.c_str());
        i = 0;
        c[i++] = 'Z';
        while(1) {
            if (*cp == 0) break;
            c[i++] = *cp++;
        }
        c[i++] = 0xd;
        c[i] = 0;
        WriteFile(hCom,c,lstrlen(c),&nn,NULL);
        readrs('U',c);
    }
    n = fd_Select;
    fd_Select = 0;
    yRdisp(c);
    fd_Select = n;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button41Click(TObject *Sender)      // UInt -> Double
{ int   i;
  unsigned long n;
  char  c[64];
  char  *cp = new char[ Edit1->Text.Length() + 1 ];
  DWORD nn;

    n = StrToInt64(Edit1->Text);
    yRegd = n;
    u_tod(yReg1,n);
    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        strcpy(cp,Edit1->Text.c_str());
        i = 0;
        c[i++] = 'Z';
        while(1) {
            if (*cp == 0) break;
            c[i++] = *cp++;
        }
        c[i++] = 0xd;
        c[i] = 0;
        WriteFile(hCom,c,lstrlen(c),&nn,NULL);
        readrs('H',c);
    }
    n = fd_Select;
    fd_Select = 1;
    yRdisp(c);
    fd_Select = n;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button37Click(TObject *Sender)      // Int -> Double
{ int   i,n;
  char  c[64];
  char  *cp = new char[ Edit1->Text.Length() + 1 ];
  DWORD nn;

    n = StrToInt(Edit1->Text);
    yRegd = n;
    i_tod(yReg1,n);
    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        strcpy(cp,Edit1->Text.c_str());
        i = 0;
        c[i++] = 'Z';
        while(1) {
            if (*cp == 0) break;
            c[i++] = *cp++;
        }
        c[i++] = 0xd;
        c[i] = 0;
        WriteFile(hCom,c,lstrlen(c),&nn,NULL);
        readrs('V',c);
    }
    n = fd_Select;
    fd_Select = 1;
    yRdisp(c);
    fd_Select = n;
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button42Click(TObject *Sender)      // Float -> UInt
{ //int   m;
  unsigned long m,n;
  char  c[64];

    if (fd_Select == 0) {
        if (xRegf < 0) xRegf = 0;
        else n = xRegf + 0.5;
        m = f_tou(xReg1);
        if ((Cpu_x <= 1) && (fRsErr == 0)) {
            readrs('g',c);
        }
        yRdispy(n,m,c);
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button38Click(TObject *Sender)      // Float -> Int
{ int   m,n;
  char  c[64];

    if (fd_Select == 0) {
        if (xRegf >= 0) {
            n = xRegf + 0.5;
            if (n < 0) n = 0x7fffffff;
        }
        else {
            n = xRegf - 0.5;
            if (n >= 0) n = 0x80000000;
        }
        m = f_toi(xReg1);
        if ((Cpu_x <= 1) && (fRsErr == 0)) {
            readrs('u',c);
        }
        yRdispx(n,m,c);
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button43Click(TObject *Sender)      // Double -> UInt
{ //int   m;
  unsigned long m,n;
  char  c[64];

    if (fd_Select == 1) {
        if (xRegd < 0) n = 0;
        else n = xRegd + 0.5;
        m = d_tou(xReg1);
        if ((Cpu_x <= 1) && (fRsErr == 0)) {
            readrs('h',c);
        }
        yRdispy(n,m,c);
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button39Click(TObject *Sender)      // Double -> Int
{ int   m,n;
  char  c[64];

    if (fd_Select == 1) {
        if (xRegd >= 0) n = xRegd + 0.5;
        else n = xRegd - 0.5;
        m = d_toi(xReg1);
        if ((Cpu_x <= 1) && (fRsErr == 0)) {
            readrs('v',c);
        }
        yRdispx(n,m,c);
    }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button7Click(TObject *Sender)       // +
{ char          c[64];

    if (fd_Select == 0) {
        xRegf += yRegf;
        f_add(xReg1,yReg1);
    }
    else {
        xRegd += yRegd;
        d_add(xReg1,yReg1);
    }
    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        readrs('+',c);
    }
    xRdisp(c);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button8Click(TObject *Sender)       // -
{ char          c[64];

    if (fd_Select == 0) {
        xRegf -= yRegf;
        f_sub(xReg1,yReg1);
    }
    else {
        xRegd -= yRegd;
        d_sub(xReg1,yReg1);
    }
    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        readrs('-',c);
    }
    xRdisp(c);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button9Click(TObject *Sender)       // *
{ char          c[64];

    if (fd_Select == 0) {
        xRegf *= yRegf;
        f_mlt(xReg1,yReg1);
    }
    else {
        xRegd *= yRegd;
        d_mlt(xReg1,yReg1);
    }
    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        readrs('*',c);
    }
    xRdisp(c);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button10Click(TObject *Sender)      // /
{ char          c[64];

    if (fd_Select == 0) {
        xRegf /= yRegf;
        f_div(xReg1,yReg1);
    }
    else {
        xRegd /= yRegd;
        d_div(xReg1,yReg1);
    }
    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        readrs('/',c);
    }
    xRdisp(c);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button11Click(TObject *Sender)      // abs
{ char          c[64];

    if (fd_Select == 0) {
        if (xRegf < 0) xRegf = -xRegf;
        f_abs(xReg1);
    }
    else {
        if (xRegd < 0) xRegd = -xRegd;
        d_abs(xReg1);
    }
    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        readrs('a',c);
    }
    xRdisp(c);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button12Click(TObject *Sender)      // int
{ char          c[64];
  int           i;

    if (fd_Select == 0) {
        i = xRegf;
        xRegf = i;
        f_int(xReg1);
    }
    else {
        i = xRegd;
        xRegd = i;
        d_int(xReg1);
    }
    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        readrs('i',c);
    }
    xRdisp(c);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button13Click(TObject *Sender)      // frac
{ char          c[64];
  int           i;
  float         f;
  double        d;

    if (fd_Select == 0) {
        i = xRegf;
        f = i;
        xRegf -= f;
        f_frac(xReg1);
    }
    else {
        i = xRegd;
        d = i;
        xRegd -= d;
        d_frac(xReg1);
    }
    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        readrs('f',c);
    }
    xRdisp(c);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button5Click(TObject *Sender)       // int
{ char          c[64];
  int           i;

    if (fd_Select == 0) {
        if (xRegf >= 0) i = xRegf + 0.5;
        else i = xRegf - 0.5;
        xRegf = i;
        i = f_toi(xReg1);
        i_tof(xReg1,i);
    }
    else {
        if (xRegd >= 0) i = xRegd + 0.5;
        else i = xRegd - 0.5;
        xRegd = i;
        i = d_toi(xReg1);
        i_tod(xReg1,i);
    }
    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        readrs('I',c);
    }
    xRdisp(c);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button6Click(TObject *Sender)       // Sign
{ char  cc[4];

    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        readrs('m',cc);
        Edit2->Text = cc;
    }
}
//---------------------------------------------------------------------------

void _paiop(int x)
{ char          c[64],a;
  float         *fp;
  double        *dp;

    if (fd_Select == 0) {
        f_pai(xReg1,x);
        fp = (float *)xReg1;
        xRegf = *fp;
    }
    else {
        d_pai(xReg1,x);
        dp = (double *)xReg1;
        xRegd = *dp;
    }
    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        if (x == 0) a = 'P';
        else a = x | 0x30;
        readrs(a,c);
    }
    xRdisp(c);
}

void __fastcall TForm1::Button14Click(TObject *Sender)      // pai
{
    _paiop(0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button15Click(TObject *Sender)      // 1.5pai
{
   _paiop(3);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button16Click(TObject *Sender)      // 2pai
{
    _paiop(1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button17Click(TObject *Sender)      // pai/2
{
    _paiop(2);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button18Click(TObject *Sender)      // pai/4
{
    _paiop(4);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button19Click(TObject *Sender)      // 180/pai
{
    _paiop(5);
}
//---------------------------------------------------------------------------

void _fn2op(int x)
{ char          c[64],a;

    if (fd_Select == 0) {
        if (x == 0) {
            xRegf = sin(xRegf);
            f_sin(xReg1);
        }
        if (x == 1) {
            xRegf = cos(xRegf);
            f_cos(xReg1);
        }
        if (x == 2) {
            xRegf = tan(xRegf);
            f_tan(xReg1);
        }
        if (x == 3) {
            xRegf = asin(xRegf);
            f_asn(xReg1);
        }
        if (x == 4) {
            xRegf = acos(xRegf);
            f_acs(xReg1);
        }
        if (x == 5) {
            xRegf = atan(xRegf);
            f_atn(xReg1);
        }
        if (x == 6) {
            xRegf = exp(xRegf);
            f_exp(xReg1);
        }
        if (x == 7) {
            xRegf = log(xRegf);
            f_ln(xReg1);
        }
        if (x == 8) {
            xRegf = log10(xRegf);
            f_log(xReg1);
        }
        if (x == 9) {
            xRegf = sqrt(xRegf);
            f_sqr(xReg1);
        }
    }
    else {
        if (x == 0) {
            xRegd = sin(xRegd);
            d_sin(xReg1);
        }
        if (x == 1) {
            xRegd = cos(xRegd);
            d_cos(xReg1);
        }
        if (x == 2) {
            xRegd = tan(xRegd);
            d_tan(xReg1);
        }
        if (x == 3) {
            xRegd = asin(xRegd);
            d_asn(xReg1);
        }
        if (x == 4) {
            xRegd = acos(xRegd);
            d_acs(xReg1);
        }
        if (x == 5) {
            xRegd = atan(xRegd);
            d_atn(xReg1);
        }
        if (x == 6) {
            xRegd = exp(xRegd);
            d_exp(xReg1);
        }
        if (x == 7) {
            xRegd = log(xRegd);
            d_ln(xReg1);
        }
        if (x == 8) {
            xRegd = log10(xRegd);
            d_log(xReg1);
        }
        if (x == 9) {
            xRegd = sqrt(xRegd);
            d_sqr(xReg1);
        }
    }
    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        if (x == 0) a = 'S';
        if (x == 1) a = 'C';
        if (x == 2) a = 'T';
        if (x == 3) a = 's';
        if (x == 4) a = 'c';
        if (x == 5) a = 't';
        if (x == 6) a = 'E';
        if (x == 7) a = 'L';
        if (x == 8) a = 'l';
        if (x == 9) a = 'Q';

        readrs(a,c);
    }
    xRdisp(c);
}

void __fastcall TForm1::Button20Click(TObject *Sender)      // Sin(x)
{
    _fn2op(0);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button21Click(TObject *Sender)      // Cos(x)
{
    _fn2op(1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button22Click(TObject *Sender)      // Tan(x)
{
    _fn2op(2);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button23Click(TObject *Sender)      // ArcSin(x)
{
    _fn2op(3);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button24Click(TObject *Sender)      // ArcCos(x)
{
    _fn2op(4);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button25Click(TObject *Sender)      // ArcTan(x)
{
    _fn2op(5);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button26Click(TObject *Sender)      // exp(x)
{
    _fn2op(6);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button27Click(TObject *Sender)      // ln(x)
{
    _fn2op(7);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button28Click(TObject *Sender)      // log(x)
{
    _fn2op(8);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button29Click(TObject *Sender)      // Sqrt(x)
{
    _fn2op(9);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button30Click(TObject *Sender)      // x^y
{ char  c[64];

    if (fd_Select == 0) {
        xRegf = pow(xRegf,yRegf);
        f_pow(xReg1,yReg1);
    }
    else {
        xRegd = pow(xRegd,yRegd);
        d_pow(xReg1,yReg1);
    }
    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        readrs('W',c);
    }
    xRdisp(c);
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Button44Click(TObject *Sender)      // 10^x
{ char  c[64];
  int   n;

    if (fd_Select == 0) {
        n = xRegf;
        xRegf = pow10(n);
        f_pow10(xReg1,f_toi(xReg1));
    }
    else {
        n = xRegd;
        xRegd = pow10(n);
        d_pow10(xReg1,d_toi(xReg1));
    }
    if ((Cpu_x <= 1) && (fRsErr == 0)) {
        readrs('w',c);
    }
    xRdisp(c);

}
//---------------------------------------------------------------------------

HANDLE RsOpen(int port,int baurate)
{ char          c[8];
  HANDLE        HndlCom;
  DCB           lpdcb;
  COMMTIMEOUTS  tout;

    if ((port < 1) || (port > 8)) port = 1;

    wsprintf(c,"COM%d:",port);
    HndlCom = CreateFile(c,
        GENERIC_READ | GENERIC_WRITE,
        0,
        NULL,
        OPEN_EXISTING,
        0,
        NULL);

    if (HndlCom != INVALID_HANDLE_VALUE) {
        GetCommState(HndlCom,&lpdcb);
        lpdcb.BaudRate = baurate;
        lpdcb.ByteSize = 8;
        lpdcb.Parity = NOPARITY;
        lpdcb.StopBits = ONESTOPBIT;
        SetCommState(HndlCom,&lpdcb);

        tout.ReadIntervalTimeout = 2;
        tout.ReadTotalTimeoutMultiplier = 2;
        tout.ReadTotalTimeoutConstant = 2;
        tout.WriteTotalTimeoutMultiplier = 2;
        tout.WriteTotalTimeoutConstant =2;
        SetCommTimeouts(HndlCom,&tout);
    }
    return(HndlCom);
}


int comout(char *c)
{ int   i,m,r;
  DWORD n;

    r = 0;
    i = 0;
    while(1) {
        m = WriteFile(hCom,c,lstrlen(c),&n,NULL);
        if (m) break;
        i++;
        if (i > 100) {
            r = 1;
            break;
        }
    }
    return(r);
}

int comin(char *c)
{ char  cc[4];
  int   i,j,r;
  DWORD n;

    r = 0;
    i = 0;
    while(1) {
        j = 0;
        while(1) {
            ReadFile(hCom,cc,1,&n,NULL);
            if (n) break;
            j++;
            if (j > 100) {
                r = 1;
                break;
            }
        }
        if (r == 1) break;
        if (cc[0] == 0xd) break;
        c[i++] = cc[0];
    }
    c[i] = 0;
    return(r);
}

int RdStr(char *c,int *i)
{ char      cx[16];
  int       j;

    j = 0;
    while(1) {
        cx[j++] = c[(*i)++];
        if ((c[*i]==',') || (c[*i]==0xd)) break;
    }
    (*i)++;
    cx[j] = 0;
    return(StrToInt(cx));
}

void IniFileRead(void)
{ char      c[64];
  int       h,i;

    h = FileOpen(INIFILE,fmOpenRead);
    if (h == -1) {
        IniFileWr();
    }
    else {
        FileRead(h,c,63);
        i = 0;
        RsPort = RdStr(c,&i);
        Cpu_x = RdStr(c,&i);
        fd_Select = RdStr(c,&i);
        n_Dispf = RdStr(c,&i);
        n_Dispd = RdStr(c,&i);
        f_Disp = RdStr(c,&i);
        FileClose(h);
    }
}

void IniFileWr(void)
{ char      c[32];
  int       h;

    h = FileOpen(INIFILE,fmOpenWrite);
    if (h == -1) {
        h = FileCreate(INIFILE);
    }

    n_Dispf = StrToInt(Form1->Edit3->Text);
    n_Dispd = StrToInt(Form1->Edit4->Text);
    wsprintf(c,"%d,%d,%d,%d,%d,%d\015",RsPort,Cpu_x,fd_Select,n_Dispf,n_Dispd,f_Disp);
    FileWrite(h,c,lstrlen(c));
    FileClose(h);
}

int fmtcalf(float x)
{ float     a,b;
  int       i;

    if (x < 0) x = -x;
    if (x <10) i = 1;
    else {
        a = 10;
        b = 100;
        for (i = 2;i<7;i++) {
            if ((x >= a) && (x < b)) break;
            a *= 10;
            b *= 10;
        }
    }
    return(i);
}

int fmtcald(double x)
{ double    a,b;
  int       i;

    if (x < 0) x = -x;
    if (x <10) i = 1;
    else {
        a = 10;
        b = 100;
        for (i = 2;i<15;i++) {
            if ((x >= a) && (x < b)) break;
            a *= 10;
            b *= 10;
        }
    }
    return(i);
}

