/*      SH7144 CPU Initialize
    Copyright(c) 2007, S.SAKAI  2007.6.13   */

#include    "iodefine.h"
#include    <machine.h>

#define     DFT_VBR    0x00000000

void bootx(void)
{

    set_imask(15);

// Set Bus
    BSC.BCR1.WORD = 0x400f;           // not MTU
    BSC.BCR2.WORD = 0x0000;           // No Idle Cycle
    BSC.WCR1.WORD = 0x2222;           // 2Wait
    BSC.WCR2.WORD = 0x0002;           // 2Wait

// Set IO Port
    PFC.PACRH.WORD = 0x0000;        	// PA15-2
    PFC.PACRL1.WORD = 0x0000;
    PFC.PACRL2.WORD = 0x0140;       	// TXD1,RXD1
    PFC.PAIORL.WORD = 0x0000;       	// IN
    PFC.PAIORH.WORD = 0x0000;

    PFC.PBCR1.WORD = 0x0000;        	// PB9-0
    PFC.PBCR2.WORD = 0x0000;
    PFC.PBIOR.WORD = 0x0000;        	// IN

    PFC.PCCR.WORD = 0x0000;         	// PC15-0
    PFC.PCIOR.WORD = 0x0000;        	// IN

    PFC.PDCRH1.WORD = 0x0000;       	// PD715-0
    PFC.PDCRH2.WORD = 0x0000;
    PFC.PDCRL1.WORD = 0x0000;
    PFC.PDCRL2.WORD = 0x0000;
    PFC.PDIORL.WORD = 0x0000;       	// IN

    PFC.PECRL1.WORD = 0x0000;       	// PE15-0
    PFC.PECRL2.WORD = 0x0000;
    PFC.PEIORL.WORD = 0x8000;       	// PE15:OUT PE14-0:IN
    PE.DRL.WORD = 0x0000;

    INTC.ICR1.WORD    = 0x0;
    INTC.ICR2.WORD    = 0x0;

    set_vbr((void *)DFT_VBR);
}
