/*      CMT0 Initialize for SH7144
    Copyright(c) 2007, S.SAKAI  2007.6.13       */

#include    "iodefine.h"
#include    "float.h"

void cmt_init(void)
{
  MST.CR2.WORD &= ~0x1000;            		// CMT Standby off

  INTC.IPRG.WORD  &= ~0x00F0;             	// CMT0 IntLevel = 7
  INTC.IPRG.WORD  |= 0x0070;

  CMT.CMSTR.WORD  &= ~0x0003;             	// CMCNT Count Stop
  CMT0.CMCSR.WORD = 0x0042;              	// Clock/128, IntEnable
  CMT0.CMCOR      = CLK2*1000/1280-1;    	// n = (CLK2 / 128) / 10Hz  (100mSec)
  CMT0.CMCSR.WORD &= ~0x0080;            	// CMF Clear
  CMT.CMSTR.WORD  |= 0x0001;              	// CMCNT0 Count Start
}

#pragma interrupt(int_cmi0)
void int_cmi0(void)
{ static unsigned char  t0;

    CMT0.CMCSR.WORD &= ~0x0080;            	// CMF Clear

    if (t0 >= 4) t0 = 0;
    else t0++;

    if (t0 <= 1) PE.DRL.WORD |= 0x8000;  	// LED Off
    else PE.DRL.WORD &= ~0x8000;         	// LED On
}
