/*
*****************************************************************************
**
**  This device driver was created by Applilet for the V850ES/JG2 and V850ES/JJ2
**  32-Bit Single-Chip Microcontrollers
**
**  Copyright(C) NEC Electronics Corporation 2002-2006
**  All rights reserved by NEC Electronics Corporation
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses incurred
**  by customers or third parties arising from the use of this file.
**
**  Filename : macrodriver.h
**  Abstract : This is the general header file
**  APIlib:    V850ESJx2.lib V1.70 [7 Dec. 2006]
**
**  Device:  uPD70F3716
**
**  Compiler:  NEC/CA850
**
*****************************************************************************
*/

#ifndef	_MDSTATUS_
#define	_MDSTATUS_
#pragma ioreg		/*enable use the register directly in ca850 compiler*/


/* data type defintion */
typedef	unsigned int	UINT;
typedef	unsigned short	USHORT;
typedef	unsigned char	UCHAR;
typedef	unsigned char	BOOL;

#define	MD_ON		1
#define	MD_OFF		0

#define	MD_TRUE	1
#define	MD_FALSE	0

#define MD_STATUS		unsigned short
#define MD_STATUSBASE		0x0
/*status list definition*/
#define MD_OK				MD_STATUSBASE+0x0	/*register setting OK*/
#define MD_RESET				MD_STATUSBASE+0x1	/*reset input*/
#define MD_SENDCOMPLETE		MD_STATUSBASE+0x2	/*send data complete*/
#define MD_ADDRESSMATCH		MD_STATUSBASE+0x3	/*IIC slave address match*/
#define MD_OVF				MD_STATUSBASE+0x4	/*timer count overflow*/
#define MD_DMA_END			MD_STATUSBASE+0x5	/*DMA transfer end*/
#define MD_DMA_CONTINUE			MD_STATUSBASE+0x6	/*DMA transfer continue*/
#define MD_SPT				MD_STATUSBASE+0x7	/*IIC stop*/
#define MD_NACK				MD_STATUSBASE+0x8 	/*IIC no ACK*/
#define MD_SLAVE_SEND_END		MD_STATUSBASE+0x9 	/*IIC slave send end*/
#define MD_SLAVE_RCV_END		MD_STATUSBASE+0x0	 /*IIC slave receive end*/
#define MD_MASTER_SEND_END		MD_STATUSBASE+0x11	 /*IIC master send end*/
#define MD_MASTER_RCV_END		MD_STATUSBASE+0x12 	/*IIC master receive end*/

/*error list definition*/
#define MD_ERRORBASE		0x80
#define MD_ERROR			MD_ERRORBASE+0x0	/*error*/
#define MD_RESOURCEERROR	MD_ERRORBASE+0x1	/*no resource available*/
#define MD_PARITYERROR		MD_ERRORBASE+0x2	/*UARTn parity error n=0,1,2*/
#define MD_OVERRUNERROR	MD_ERRORBASE+0x3	/*UARTn overrun error n=0,1,2*/
#define MD_FRAMEERROR		MD_ERRORBASE+0x4	/*UARTn frame error n=0,1,2*/
#define MD_ARGERROR		MD_ERRORBASE+0x5	/*Error agrument input error*/
#define MD_TIMINGERROR		MD_ERRORBASE+0x6	/*Error timing operation error*/
#define MD_SETPROHIBITED		MD_ERRORBASE+0x7	/*setting prohibited*/
#define MD_ODDBUF		MD_ERRORBASE+0x8	/*in 16bit transfer mode,buffer size should be even*/
#define MD_DATAEXISTS		MD_ERRORBASE+0x9	/*Data to be transferred next exists in TXBn register*/

/* macro fucntion definiton */
/*main clock and subclock as clock source*/
enum ClockMode { MainClock, SubClock };
/*timer input channel*/
enum TMChannel { TMChannel0, TMChannel1, TMChannel2, TMChannel3 };
enum INTLevel{ Highest, Level1, Level2, Level3, Level4, Level5, Level6, Lowest };
enum TrigEdge { None, RisingEdge, FallingEdge, BothEdge };
/*clear IO register bit and set IO register bit */
#define ClrIORBit(Reg,ClrBitMap)	Reg&=~ClrBitMap
#define SetIORBit(Reg,SetBitMap)	Reg|=SetBitMap

#define	SYSTEMCLOCK	20000000
#define	SUBCLOCK	32768
#define	MAINCLOCK	5000000
#define	FRCLOCK	200000
#define	FxInuse	0

#endif 
