/*  Floating Point Calculation Library Test Program
        Copyright(c) 2007, S.SAKAI  2007.6.13
*/
/*
*****************************************************************************
**
**  This device driver was created by Applilet for the V850ES/JG2 and V850ES/JJ2
**  32-Bit Single-Chip Microcontrollers
**
**  Copyright(C) NEC Electronics Corporation 2002-2006
**  All rights reserved by NEC Electronics Corporation
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses incurred
**  by customers or third parties arising from the use of this file.
**
**  Filename : main.c
**  Abstract : This file implements main function
**  APIlib :   V850ESJx2.lib V1.70 [7 Dec. 2006]
**
**  Device:  uPD70F3716
**
**  Compiler:  NEC/CA850
**
*****************************************************************************
*/
/*
** **************************************************************************
** Include files
** **************************************************************************
*/
#include "macrodriver.h"
#include "serial.h"
/*
** **************************************************************************
** MacroDefine
** **************************************************************************
*/

/*
**---------------------------------------------------------------------------
**
**  Abstract:
**      main function
**
**  Parameters:
**      None
**
**  Returns:
**      None
**
**---------------------------------------------------------------------------
*/
void    outreg(unsigned char *);
void    outregx(int,int);
void    btoh(char *,char);
int     a_toi(char *);

int     fd,f_Disp=0;
int     ketaf,ketad;
int     fpoint,dpoint;

void  main( void )
{ int       i,s,n,zreg;
  short     data,x;
  char      buf[64],cc[16];
  unsigned char xreg[8],yreg[8];

    fd = 0;
    s = 0;

    ketaf = 4;
    ketad = 8;
    fpoint = -ketaf;
    dpoint = -ketad;

    while (1) {
        if (s == 0) {
            data = sci1_getc();
            if (data >= 0) {
                n = 0;
                if (data == 'F') fd = 0;
                if (data == 'D') fd = 1;
                if (data == 'X') s = 1;
                if (data == 'Y') s = 1;
                if (data == '+') s = 2;
                if (data == '-') s = 2;
                if (data == '*') s = 2;
                if (data == '/') s = 2;
                if (data == 'x') outreg(xreg);
                if (data == 'y') outreg(yreg);

                if (data == 'S') {
                    if (fd == 0) f_sin(xreg);
                    else d_sin(xreg);
                    outreg(xreg);
                }
                if (data == 'C') {
                    if (fd == 0) f_cos(xreg);
                    else d_cos(xreg);
                    outreg(xreg);
                }
                if (data == 'T') {
                    if (fd == 0) f_tan(xreg);
                    else d_tan(xreg);
                    outreg(xreg);
                }
                if (data == 's') {
                    if (fd == 0) f_asn(xreg);
                    else d_asn(xreg);
                    outreg(xreg);
                }
                if (data == 'c') {
                    if (fd == 0) f_acs(xreg);
                    else d_acs(xreg);
                    outreg(xreg);
                }
                if (data == 't') {
                    if (fd == 0) f_atn(xreg);
                    else d_atn(xreg);
                    outreg(xreg);
                }
                if (data == 'E') {
                    if (fd == 0) f_exp(xreg);
                    else d_exp(xreg);
                    outreg(xreg);
                }
                if (data == 'L') {
                    if (fd == 0) f_ln(xreg);
                    else d_ln(xreg);
                    outreg(xreg);
                }
                if (data == 'l') {
                    if (fd == 0) f_log(xreg);
                    else d_log(xreg);
                    outreg(xreg);
                }
                if (data == 'Q') {
                    if (fd == 0) f_sqr(xreg);
                    else d_sqr(xreg);
                    outreg(xreg);
                }
                if (data == 'W') {
                    if (fd == 0) f_pow(xreg,yreg);
                    else d_pow(xreg,yreg);
                    outreg(xreg);
                }
                if (data == 'w') {
                    if (fd == 0) f_pow10(xreg,f_toi(xreg));
                    else d_pow10(xreg,d_toi(xreg));
                    outreg(xreg);
                }
                if (data == 'P') {
                    if (fd == 0) f_pai(xreg,0);
                    else d_pai(xreg,0);
                    outreg(xreg);
                }
                if (data == '1') {
                    if (fd == 0) f_pai(xreg,1);
                    else d_pai(xreg,1);
                    outreg(xreg);
                }
                if (data == '2') {
                    if (fd == 0) f_pai(xreg,2);
                    else d_pai(xreg,2);
                    outreg(xreg);
                }
                if (data == '3') {
                    if (fd == 0) f_pai(xreg,3);
                    else d_pai(xreg,3);
                    outreg(xreg);
                }
                if (data == '4') {
                    if (fd == 0) f_pai(xreg,4);
                    else d_pai(xreg,4);
                    outreg(xreg);
                }
                if (data == '5') {
                    if (fd == 0) f_pai(xreg,5);
                    else d_pai(xreg,5);
                    outreg(xreg);
                }
                if (data == 'r') {
                    if (fd == 0) f_rad(xreg);
                    else d_rad(xreg);
                    outreg(xreg);
                }
                if (data == 'd') {
                    if (fd == 0) f_deg(xreg);
                    else d_deg(xreg);
                    outreg(xreg);
                }
                if (data == 'I') {                  /* float->int */
                    if (fd == 0) {
                        i = f_toi(xreg);
                        i_tof(xreg,i);
                    }
                    else {
                        i = d_toi(xreg);
                        i_tod(xreg,i);
                    }
                    outreg(xreg);
                }
                if (data == 'i') {
                    if (fd == 0) f_int(xreg);
                    else d_int(xreg);
                    outreg(xreg);
                }
                if (data == 'f') {
                    if (fd == 0) f_frac(xreg);
                    else d_frac(xreg);
                    outreg(xreg);
                }
                if (data == 'a') {
                    if (fd == 0) f_abs(xreg);
                    else d_abs(xreg);
                    outreg(xreg);
                }
                if (data == 'n') {
                    if (fd == 0) f_neg(xreg);
                    else d_neg(xreg);
                    outreg(xreg);
                }
                if (data == 'e') {
                    if (fd == 0) f_xchg(xreg,yreg);
                    else d_xchg(xreg,yreg);
                }
                if (data == 'm') {
                    if (fd == 0) n = f_sgn(xreg);
                    else n = d_sgn(xreg);
                    if (n == 0) x = '0';
                    if (n > 0) x = '+';
                    if (n < 0) x = '-';
                    sci1_putc(x);
                    sci1_putc(0xd);
                }

                if (data == 'A') {                  /* Float -> Double */
                    if (fd == 0) {
                        f_tod(yreg,xreg);
                        fd = 1;
                        outreg(yreg);
                        fd = 0;
                    }
                }
                if (data == 'B') {                  /* Double -> Float */
                    if (fd != 0) {
                        d_tof(yreg,xreg);
                        fd = 0;
                        outreg(yreg);
                        fd = 1;
                    }
                }

                if (data == 'Z') {
                    s = 3;
                }

                if (data == 'U') {                  /* Int -> Float */
                    i_tof(yreg,zreg);
                    i = fd;
                    fd = 0;
                    outreg(yreg);
                    fd = i;
                }
                if (data == 'V') {                  /* Int -> Double */
                    i_tod(yreg,zreg);
                    i = fd;
                    fd = 1;
                    outreg(yreg);
                    fd = i;
                }
                if (data == 'u') {                  /* Float -> Int */
                    zreg = f_toi(xreg);
                    outregx(zreg,0);
                }
                if (data == 'v') {                  /* Double -> Int */
                    zreg = d_toi(xreg);
                    outregx(zreg,0);
                }

                if (data == 'G') {                  /* UInt -> Float */
                    u_tof(yreg,zreg);
                    i = fd;
                    fd = 0;
                    outreg(yreg);
                    fd = i;
                }
                if (data == 'H') {                  /* UInt -> Double */
                    u_tod(yreg,zreg);
                    i = fd;
                    fd = 1;
                    outreg(yreg);
                    fd = i;
                }
                if (data == 'g') {                  /* Float -> UInt */
                    zreg = f_tou(xreg);
                    outregx(zreg,1);
                }
                if (data == 'h') {                  /* Double -> UInt */
                    zreg = d_tou(xreg);
                    outregx(zreg,1);
                }

                if (data == 'K') {
                    f_Disp = 1;
                    fpoint = -ketaf;
                    dpoint = -ketad;
                }
                if (data == 'k') {
                    f_Disp = 0;
                    fpoint = ketaf;
                    dpoint = ketad;
                }

                if (data == 'J') s = 4;                 /* Double Keta */
                if (data == 'j') s = 4;                 /* Float Keta */

            }
        }

        if (s == 1) {
            x = sci1_getc();
            if (x == 0xd) {
                buf[n] = 0;
                if (fd == 0) {
                    if (data == 'X') a_tof(buf,xreg);
                    else a_tof(buf,yreg);
                }
                else {
                    if (data == 'X') a_tod(buf,xreg);
                    else a_tod(buf,yreg);
                }
                s = 0;
            }
            if (x > 0) buf[n++] = x;
        }

        if (s == 2) {
            if (fd == 0) {
                if (data == '+') f_add(xreg,yreg);
                if (data == '-') f_sub(xreg,yreg);
                if (data == '*') f_mlt(xreg,yreg);
                if (data == '/') f_div(xreg,yreg);
            }
            else {
                if (data == '+') d_add(xreg,yreg);
                if (data == '-') d_sub(xreg,yreg);
                if (data == '*') d_mlt(xreg,yreg);
                if (data == '/') d_div(xreg,yreg);
            }
            outreg(xreg);
            s = 0;
        }
        if (s == 3) {
            x = sci1_getc();
            if (x == 0xd) {
                buf[n] = 0;
                i = 0;
                n = 0;
                zreg = 0;
                while(1) {
                    if (buf[i] == 0) break;
                    if (buf[i] == '-') n = 1;
                    else {
                        zreg = zreg * 10 + (buf[i] & 0xf);
                    }
                    i++;
                }
                if (n) zreg = -zreg;
                s = 0;
            }
            if (x > 0) {
                buf[n++] = x;
            }
        }

        if (s == 4) {
            x = sci1_getc();
            if (x == 0xd) {
                buf[n] = 0;
                if (data == 'J') {
                    ketad = a_toi(buf);
                    if (f_Disp == 0) dpoint = ketad;
                    else dpoint = -ketad;
                }
                else {
                    ketaf = a_toi(buf);
                    if (f_Disp == 0) fpoint = ketaf;
                    else fpoint = -ketaf;
                }
                s = 0;
            }
            else if (x > 0) buf[n++] = x;
        }

    }
}

void btoh(char *c,char x)
{ int   a;

    a = x;
    a >>= 4;
    a &= 0xf;
    a |= 0x30;
    if (a > '9') a += 7;
    c[0] = a;

    a = x;
    a &= 0xf;
    a |= 0x30;
    if (a > '9') a += 7;
    c[1] = a;
    c[2] = ' ';
    c[3] = 0;
}

void outreg(unsigned char *reg)
{ char  c[64],cc[8];
  int   i,j,k;

    j = 0;
    if (fd == 0) k = 4;
    else k = 8;
    for(i=0;i<k;i++) {
        btoh(cc,reg[i]);
        c[j++] = cc[0];
        c[j++] = cc[1];
        c[j++] = cc[2];
    }
    c[j++] = ' ';
    if (fd == 0) f_toa(c+j,reg,fpoint);
    else d_toa(c+j,reg,dpoint);
    j = strlen(c);
    c[j] = 0xd;
    c[j+1] = 0;
    sci1_puts((unsigned char *)c,strlen(c));
}

void outregx(int x,int n)
{ int           i,j;
  char          c[64],cc[8],*pb,*pc;
  unsigned int  z;

    i = 63;
    if (n == 0) {
        if (x < 0) z = -x;
        else z = x;
    }
    else z = x;
    c[i--] = 0;
    while(1) {
        if (z < 10) {
            c[i--] = z | 0x30;
            if (n == 0) {
                if (x == 0) c[i] = ' ';
                if (x < 0) c[i] = '-';
                if (x > 0) c[i] = '+';
            }
            else {
                if (x == 0) c[i] = ' ';
                else c[i] = '+';
            }
            break;
        }
        else {
            c[i--] = (z % 10) | 0x30;
            z /= 10;
        }
    }
    pb = c + i;

    j = 0;
    pc = (char *)&x;
    for(i=0;i<4;i++) {
        btoh(cc,*pc++);
        c[j++] = cc[0];
        c[j++] = cc[1];
        c[j++] = cc[2];
    }
    c[j++] = ' ';
    while(1) {
        if (*pb == 0) break;
        c[j++] = *pb++;
    }
    c[j++] = 0xd;
    c[j] = 0;
    sci1_puts((unsigned char *)c,strlen(c));
}

int a_toi(char *c)
{ int   i,x;

    x = 0;
    i = 0;
    while(c[i]) {
        x = x * 10 + (c[i++] & 0xf);
    }
    return(x);
}
