/*
*******************************************************************************
**
**  This device driver was created by Applilet for the V850ES/JG2, V850ES/JJ2
**  32-Bit Single-Chip Microcontrollers
**
**  Copyright(C) NEC Electronics Corporation 2002-2006
**  All rights reserved by NEC Electronics Corporation
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	port.c
**  Abstract :	This file implements a device driver for the port module
**  APIlib :	V850ESJx2.lib V1.70 [7 Dec. 2006]
**
**  Device :	uPD70F3716
**
**  Compiler :	NEC/CA850
**
*******************************************************************************
*/
/*
**===========================================================================
** Include files
**===========================================================================
*/
#include "macrodriver.h"
#include "port.h"

/*
**===========================================================================
** Constants
**===========================================================================
*/ 

/*
**---------------------------------------------------------------------------
**
**  Abstract:
**      Initialize the I/O module
**
**  Parameters:
**      None
**
**  Returns:
**      None
**
**---------------------------------------------------------------------------
*/ 
void PORT_Init( void )
{	
	/* initialize the port registers */
	P0 = PORT_P0;
	P1 = PORT_P1;
	P3 = PORT_P3;
	P4 = PORT_P4;
	P5 = PORT_P5;
	P7L = PORT_P7L;
	P7H = PORT_P7H;
	P9 = PORT_P9;
	PCM = PORT_PCM;
	PCT = PORT_PCT;
	PDH = PORT_PDH;
	PDL = PORT_PDL;
	
	/* initialize the function registers */
	PF0 = PORT_PF0;
	PF3 = PORT_PF3;
	PF4 = PORT_PF4;
	PF5 = PORT_PF5;
	PF9 = PORT_PF9;
		
	 /* initialize the mode registers */
	PM0 = PORT_PM0;
	PM1 = PORT_PM1;
	PM3 = PORT_PM3;
	PM4 = PORT_PM4;
	PM5 = PORT_PM5;
	PM7L = PORT_PM7L;
	PM7H = PORT_PM7H;
	PM9 = PORT_PM9;
	PMCM = PORT_PMCM;
	PMCT = PORT_PMCT;
	PMDH = PORT_PMDH;
	PMDL = PORT_PMDL;
	
	 /* initialize the mode control registers */
	PMC0 &= ~PORT_PMC0;
	PMC3 &= ~PORT_PMC3;
	PMC4 &= ~PORT_PMC4;
	PMC5 &= ~PORT_PMC5;
	PMC9 &= ~PORT_PMC9;
	PMCCM &= ~PORT_PMCCM;
	
	PMCCT &= ~PORT_PMCCT;
	PMCDH &= ~PORT_PMCDH;
	PMCDL &= ~PORT_PMCDL;
	return;
}
