--/*
--*****************************************************************************
--**
--**  This device driver was created by Applilet for the V850ES/JG2 and V850ES/JJ2
--**  32-Bit Single-Chip Microcontrollers
--**
--**  Copyright(C) NEC Electronics Corporation 2002-2006
--**  All rights reserved by NEC Electronics Corporation
--**
--**  This program should be used on your own responsibility.
--**  NEC Electronics Corporation assumes no responsibility for any losses incurred
--**  by customers or third parties arising from the use of this file.
--**
--**  Filename : system.s
--**  Abstract : This file implements a device driver for the SYSTEM module
--**  APIlib: v850esJx2.lib V1.70 [7 Dec. 2006]
--**
--  Device:  uPD70F3716
--
--  Compiler:  NEC/CA850
--
--*****************************************************************************
--*/
	.include "system.inc"
		.text
	.globl	_Clock_Init
	.align	4

--/*
--**---------------------------------------------------------------------------
--**
--**  Abstract:
--**	Init the Clock Generator and Watchdog timer 2
--**
--**  Parameters:
--**	None
--**
--**  Returns:
--**	None
--**
--**---------------------------------------------------------------------------
--*/
_Clock_Init:

	add	 -8, sp
	st.w	r11, 0[sp]
	st.w	r12, 4[sp]

	ld.b	DCHC0[r0], r11			-- stop DMA0
	add	-1, sp
	st.b	r11, 0[sp]
	andi	0xfe, r11, r11
	st.b	r11, DCHC0[r0]
	
	ld.b	DCHC1[r0], r11			-- stop DMA1
	add	-1, sp
	st.b	r11, 0[sp]
	andi	0xfe, r11, r11
	st.b	r11, DCHC1[r0]
	
	ld.b	DCHC2[r0], r11			-- stop DMA2
	add	-1, sp
	st.b	r11, 0[sp]
	andi	0xfe, r11, r11
	st.b	r11, DCHC2[r0]
	
	ld.b	DCHC3[r0], r11			-- stop DMA3
	add	-1, sp
	st.b	r11, 0[sp]
	andi	0xfe, r11, r11
	st.b	r11, DCHC3[r0]
	
	-- disable interrupt
	stsr	5, r11
	ori	0xa0, r11, r11
	ldsr	r11, 5

	mov	r0, r11
	st.b	r11, PRCMD[r0]
	st.b	r11, CLM[r0]			--disable clock monitor function

	nop
	nop
	nop
	nop
	nop
	ld.b	PCC[r0], r12
	andi	0xf8, r12, r12
	or		r12, r11
	st.b	r11, PRCMD[r0]
	st.b	r11, PCC[r0]

	nop
	nop
	nop
	nop
	nop
	-- Sub clock -> Main clock start
	-- stop Main clock
	st.b	r0, PRCMD[r0]
	clr1	6, PCC[r0]
	-- this wait loop per 250usec
	movea	0x1000, r0, r11

	__CG_LOOP2:
	nop
	nop
	nop

	addi	-1, r11, r11
	cmp	r0, r11
	bnz	__CG_LOOP2
	st.b	r0, PRCMD[r0]
	
	clr1	3, PCC[r0]
	__CG_LOOP3:
	-- Check CLS
	tst1	4, PCC[r0]
	bnz	__CG_LOOP3

	-- Sub -> Main  end
	-- enable RingOSC
	clr1	0, RCM[r0]
	-- 2^13/fx
	mov	3, r11
	st.b	r11, PLLS[r0]
	mov	0x0a, r11			-- fxx = 4*fx
	st.b	r11, PRCMD[r0]
	st.b	r11, CKC[r0]
	nop
	nop
	nop
	nop
	nop
	-- PLL start
	set1	0, PLLCTL[r0]
	-- PLL work
	__CG_LOOP4:
	ld.b	LOCKR[r0], r11
	cmp	r0, r11
	bnz	__CG_LOOP4
	set1	1, PLLCTL[r0]
	-- enable interrupt
	stsr	5, r11
	andi	0x5f, r11, r11
	ldsr	r11, 5

	ld.b	0[sp], r11			-- recover DMA3
	add	1, sp
	st.b	r11, DCHC3[r0]
	
	ld.b	0[sp], r11			-- recover DMA2
	add	1, sp
	st.b	r11, DCHC2[r0]
	
	ld.b	0[sp], r11			-- recover DMA1
	add	1, sp
	st.b	r11, DCHC1[r0]
	
	ld.b	0[sp], r11			-- recover DMA0
	add	1, sp
	st.b	r11, DCHC0[r0]
	-- oscollation stabilization time
	-- selection clock
	-- 2^16/fx
	mov	0x6, r11
	st.b	r11, OSTS[r0]
	mov	0x1f, r11
	st.b	r11, WDTM2[r0]
	-- pop
	ld.w	0[sp], r11
	ld.w	4[sp], r12
	add	8, sp
	
	jmp	[lp]
