/*
*****************************************************************************
**
**  This device driver was created by Applilet for the V850ES/JG2 and V850ES/JJ2
**  32-Bit Single-Chip Microcontrollers
**
**  Copyright(C) NEC Electronics Corporation 2002-2006
**  All rights reserved by NEC Electronics Corporation
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses incurred
**  by customers or third parties arising from the use of this file.
**
**  Filename : systeminit.c
**  Abstract : This file implements macro initiate
**  APIlib: v850esJx2.lib V1.70 [7 Dec. 2006]
**
**  Device:  uPD70F3716
**
**  Compiler:  NEC/CA850
**
*****************************************************************************
*/
/*
** **************************************************************************
** Include files
** **************************************************************************
*/
#include "macrodriver.h"
#include "port.h"
#include "timer.h"
#include "serial.h"
/*
** **************************************************************************
** MacroDefine
** **************************************************************************
*/
extern unsigned long _S_romp;
/*
**---------------------------------------------------------------------------
**
**  Abstract:
**	Init every Macro
**
**  Parameters:
**	None
**
**  Returns:
**	None
**
**---------------------------------------------------------------------------
*/
void  SystemInit( void )
{
	_rcopy(&_S_romp, -1);

	ClrIORBit(DCHC0, 0x1);		/* disable dma0 - dma3 */
	ClrIORBit(DCHC1, 0x1);
	ClrIORBit(DCHC2, 0x1);
	ClrIORBit(DCHC3, 0x1);

	VSWC = 0x01;			/* mainclock (2MHz, 16.6MHz) 1wait */

	__DI( );			/* disable interrupt */

	PORT_Init( );			/* Port initiate */
	UART0_Init( );			/* UART0 initiate */
	TMM_Init( );			/* TMM initiate */
	__EI( );			/* enable interrupt */
}

