/*  Timer Program for Floating Point Calculation Library Test Program
        Copyright(c) 2007, S.SAKAI  2007.6.13
*/
/*
*******************************************************************************
**
**  This device driver was created by Applilet for the V850ES/JG2, V850ES/JJ2
**  32-Bit Single-Chip Microcontrollers
**
**  Copyright(C) NEC Electronics Corporation 2002-2006
**  All rights reserved by NEC Electronics Corporation
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :  timer.c
**  Abstract :  This file implements a device driver for the timer module
**  APIlib :    V850ESJx2.lib V1.70 [7 Dec. 2006]
**
**  Device :    uPD70F3716
**
**  Compiler :  NEC/CA850
**
*******************************************************************************
*/
/*
*******************************************************************************
**  Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "timer.h"
#pragma interrupt INTTM0EQ0 MD_INTTM0EQ0

/*
**-----------------------------------------------------------------------------
**
**  Abstract:
**  This function initializes TMM.
**
**  Parameters:
**  None
**
**  Returns:
**  None
**
**-----------------------------------------------------------------------------
*/
void TMM_Init( void )
{
    TM0CTL0 = 0;                    /* stop TMM */
    SetIORBit(TM0EQIC0, 0x40);      /* mask interrupt */
    ClrIORBit(TM0EQIC0, 0x80);      /* clear IF flag */
    
    TM0CTL0 |= TM_TMM_CLOCK;        /* count clock */
    
    TM0CMP0 = TM_TMM_INTERVALVALUE;
    /* interrupt INTTM0EQ */
    SetIORBit(TM0EQIC0, 0x07);

    ClrIORBit(TM0EQIC0, 0x40);      /* enable interrupt INTTM0EQ */
    SetIORBit(TM0CTL0, 0x80);       /* start counting */
}

__interrupt void MD_INTTM0EQ0( void )
{ static unsigned char  t0;

    if (t0 >= 4) t0 = 0;
    else t0++;

    if (t0 <= 1) PCT &= ~0x40;      /* LED ON */
    else PCT |= 0x40;               /* LED OFF */
}

